/* Generated by Pyrex 0.9.4.1 on Thu May 25 13:07:34 2006 */

#include "Python.h"
#include "structmember.h"
#ifndef PY_LONG_LONG
  #define PY_LONG_LONG LONG_LONG
#endif
#ifdef __cplusplus
#define __PYX_EXTERN_C extern "C"
#else
#define __PYX_EXTERN_C extern
#endif
__PYX_EXTERN_C double pow(double, double);


typedef struct {PyObject **p; char *s;} __Pyx_InternTabEntry; /*proto*/
typedef struct {PyObject **p; char *s; long n;} __Pyx_StringTabEntry; /*proto*/
static PyObject *__Pyx_UnpackItem(PyObject *, int); /*proto*/
static int __Pyx_EndUnpack(PyObject *, int); /*proto*/
static int __Pyx_PrintItem(PyObject *); /*proto*/
static int __Pyx_PrintNewline(void); /*proto*/
static void __Pyx_Raise(PyObject *type, PyObject *value, PyObject *tb); /*proto*/
static void __Pyx_ReRaise(void); /*proto*/
static PyObject *__Pyx_Import(PyObject *name, PyObject *from_list); /*proto*/
static PyObject *__Pyx_GetExcValue(void); /*proto*/
static int __Pyx_ArgTypeTest(PyObject *obj, PyTypeObject *type, int none_allowed, char *name); /*proto*/
static int __Pyx_TypeTest(PyObject *obj, PyTypeObject *type); /*proto*/
static int __Pyx_GetStarArgs(PyObject **args, PyObject **kwds, char *kwd_list[], int nargs, PyObject **args2, PyObject **kwds2); /*proto*/
static void __Pyx_WriteUnraisable(char *name); /*proto*/
static void __Pyx_AddTraceback(char *funcname); /*proto*/
static PyTypeObject *__Pyx_ImportType(char *module_name, char *class_name, long size);  /*proto*/
static int __Pyx_SetVtable(PyObject *dict, void *vtable); /*proto*/
static int __Pyx_GetVtable(PyObject *dict, void *vtabptr); /*proto*/
static PyObject *__Pyx_CreateClass(PyObject *bases, PyObject *dict, PyObject *name, char *modname); /*proto*/
static int __Pyx_InternStrings(__Pyx_InternTabEntry *t); /*proto*/
static int __Pyx_InitStrings(__Pyx_StringTabEntry *t); /*proto*/
static PyObject *__Pyx_GetName(PyObject *dict, PyObject *name); /*proto*/

static PyObject *__pyx_m;
static PyObject *__pyx_b;
static int __pyx_lineno;
static char *__pyx_filename;
static char **__pyx_f;

static char __pyx_mdoc[] = "\nBase class for objects with generators\n\nMany objects in SAGE are equipped with generators, which are special\nelements of the object.  For example, the polynomial ring $\\Z[x,y,z]$\nis generated by $x$, $y$, and $z$.  In SAGE the $i$th generator of an\nobject \\code{X} is obtained using the notation \\code{X.gen(i)}.  From\nthe SAGE interactive prompt, the shorthand notation \\code{X.i} is also\nallowed.\n\nA class that derives from Generators \\emph{must} define a gen(i)\nfunction.\n\nThe \\code{gens} function returns a tuple of all generators, the\n\\code{ngens} function returns the number of generators, and the\n\\code{assign_names}, \\code{name} and \\code{names} functions allow one\nto change or obtain the way generators are printed. (They \\emph{only}\naffect printing!)\n\nThe following examples illustrate these functions in the context of\nmultivariate polynomial rings and free modules.\n\nEXAMPLES:\n    sage: R = MPolynomialRing(IntegerRing(), 3)\n    sage: R.ngens()\n    3\n    sage: R.gen(0)\n    x0\n    sage: R.gens()\n    (x0, x1, x2)\n    sage: R.variable_names()\n    (\'x0\', \'x1\', \'x2\')\n    sage: R.assign_names([\'a\', \'b\', \'c\'])\n    sage: R\n    Polynomial Ring in a, b, c over Integer Ring\n\nThis example illustrates generators for a free module over $\\Z$.\n\n    sage: M = FreeModule(IntegerRing(), 4)\n    sage: M\n    Ambient free module of rank 4 over the principal ideal domain Integer Ring\n    sage: M.ngens()\n    4\n    sage: M.gen(0)\n    (1, 0, 0, 0)\n    sage: M.gens()\n    ((1, 0, 0, 0), (0, 1, 0, 0), (0, 0, 1, 0), (0, 0, 0, 1))\n\nThe names of the generators of a free module aren\'t really used anywhere,\nbut they are still defined:\n\n    sage: M.variable_names()   \n    (\'x0\', \'x1\', \'x2\', \'x3\')\n";

/* Declarations from sage_object */


struct __pyx_obj_11sage_object_SageObject {
  PyObject_HEAD
};

static PyTypeObject *__pyx_ptype_11sage_object_SageObject = 0;

/* Declarations from gens */


struct __pyx_obj_4gens_Generators {
  struct __pyx_obj_11sage_object_SageObject __pyx_base;
};


struct __pyx_obj_4gens_MultiplicativeAbelianGenerators {
  struct __pyx_obj_4gens_Generators __pyx_base;
};


struct __pyx_obj_4gens_AdditiveAbelianGenerators {
  struct __pyx_obj_4gens_Generators __pyx_base;
};

static PyTypeObject *__pyx_ptype_4gens_Generators = 0;
static PyTypeObject *__pyx_ptype_4gens_MultiplicativeAbelianGenerators = 0;
static PyTypeObject *__pyx_ptype_4gens_AdditiveAbelianGenerators = 0;
static PyObject *__pyx_k3;
static PyObject *__pyx_k4;
static PyObject *__pyx_k5;
static PyObject *__pyx_k6;
static PyObject *__pyx_k7;
static PyObject *__pyx_k8;

/* Implementation of gens */

static char (__pyx_k1[]) = "sage.misc.defaults";

static PyObject *__pyx_n_sage_object;
static PyObject *__pyx_n_sage;
static PyObject *__pyx_n_gens_py;
static PyObject *__pyx_n_True;

static PyObject *__pyx_k1p;

static PyObject *__pyx_n_NotImplementedError;

static PyObject *__pyx_k9p;

static char (__pyx_k9[]) = "Number of generators not known.";

static PyObject *__pyx_f_4gens_10Generators_ngens(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_4gens_10Generators_ngens(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF((PyObject *)__pyx_v_self);

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":82 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 82; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, __pyx_k9p, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 82; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("gens.Generators.ngens");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF((PyObject *)__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_k10p;

static char (__pyx_k10[]) = "i-th generator not known.";

static PyObject *__pyx_f_4gens_10Generators_gen(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_4gens_10Generators_gen(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_i = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"i",0};
  __pyx_v_i = __pyx_k3;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_i)) return 0;
  Py_INCREF((PyObject *)__pyx_v_self);
  Py_INCREF(__pyx_v_i);

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":86 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 86; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, __pyx_k10p, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 86; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("gens.Generators.gen");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF((PyObject *)__pyx_v_self);
  Py_DECREF(__pyx_v_i);
  return __pyx_r;
}

static PyObject *__pyx_n_list;
static PyObject *__pyx_n_int;

static PyObject *__pyx_f_4gens_10Generators___getitem__(PyObject *__pyx_v_self, PyObject *__pyx_v_n); /*proto*/
static PyObject *__pyx_f_4gens_10Generators___getitem__(PyObject *__pyx_v_self, PyObject *__pyx_v_n) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  Py_INCREF((PyObject *)__pyx_v_self);
  Py_INCREF(__pyx_v_n);

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":89 */
  __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n_list); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 89; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 89; goto __pyx_L1;}
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 89; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_int); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 89; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 89; goto __pyx_L1;}
  Py_INCREF(__pyx_v_n);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_n);
  __pyx_4 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 89; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_1 = PyObject_GetItem(__pyx_3, __pyx_4); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 89; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("gens.Generators.__getitem__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF((PyObject *)__pyx_v_self);
  Py_DECREF(__pyx_v_n);
  return __pyx_r;
}

static PyObject *__pyx_f_4gens_10Generators___getslice__(PyObject *__pyx_v_self, int __pyx_arg_n, int __pyx_arg_m); /*proto*/
static PyObject *__pyx_f_4gens_10Generators___getslice__(PyObject *__pyx_v_self, int __pyx_arg_n, int __pyx_arg_m) {
  PyObject *__pyx_v_n = 0;
  PyObject *__pyx_v_m = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  int __pyx_5;
  int __pyx_6;
  Py_INCREF((PyObject *)__pyx_v_self);
  __pyx_v_n = PyInt_FromLong(__pyx_arg_n); if (!__pyx_v_n) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 91; goto __pyx_L1;}
  __pyx_v_m = PyInt_FromLong(__pyx_arg_m); if (!__pyx_v_m) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 91; goto __pyx_L1;}

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":92 */
  __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n_list); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 92; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 92; goto __pyx_L1;}
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 92; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_int); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 92; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 92; goto __pyx_L1;}
  Py_INCREF(__pyx_v_n);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_n);
  __pyx_4 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 92; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_5 = PyInt_AsLong(__pyx_4); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 92; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_int); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 92; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 92; goto __pyx_L1;}
  Py_INCREF(__pyx_v_m);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_m);
  __pyx_4 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 92; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_6 = PyInt_AsLong(__pyx_4); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 92; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  __pyx_1 = PySequence_GetSlice(__pyx_3, __pyx_5, __pyx_6); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 92; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("gens.Generators.__getslice__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_n);
  Py_DECREF(__pyx_v_m);
  Py_DECREF((PyObject *)__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_n_len;

static int __pyx_f_4gens_10Generators___len__(PyObject *__pyx_v_self); /*proto*/
static int __pyx_f_4gens_10Generators___len__(PyObject *__pyx_v_self) {
  int __pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  int __pyx_5;
  Py_INCREF((PyObject *)__pyx_v_self);

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":95 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_len); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 95; goto __pyx_L1;}
  __pyx_2 = PyObject_GetAttr(__pyx_v_self, __pyx_n_list); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 95; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 95; goto __pyx_L1;}
  __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 95; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 95; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_4);
  __pyx_4 = 0;
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 95; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_5 = PyInt_AsLong(__pyx_3); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 95; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_r = __pyx_5;
  goto __pyx_L0;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("gens.Generators.__len__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF((PyObject *)__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_n___list;
static PyObject *__pyx_n_AttributeError;
static PyObject *__pyx_n___iter__;

static PyObject *__pyx_f_4gens_10Generators_list(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4gens_10Generators_list[] = "\n        Return a list of all elements in this object, if possible (the\n        object must define an iterator).\n        ";
static PyObject *__pyx_f_4gens_10Generators_list(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF((PyObject *)__pyx_v_self);

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":102 */
  /*try:*/ {

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":103 */
    __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n___list); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 103; goto __pyx_L2;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;
  }
  goto __pyx_L3;
  __pyx_L2:;
  Py_XDECREF(__pyx_1); __pyx_1 = 0;

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":104 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_AttributeError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 104; goto __pyx_L1;}
  __pyx_2 = PyErr_ExceptionMatches(__pyx_1);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  if (__pyx_2) {
    __Pyx_AddTraceback("gens.list");
    __pyx_1 = __Pyx_GetExcValue(); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 104; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":105 */
    __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_list); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 105; goto __pyx_L1;}
    __pyx_3 = PyObject_GetAttr(__pyx_v_self, __pyx_n___iter__); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 105; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 105; goto __pyx_L1;}
    __pyx_5 = PyObject_CallObject(__pyx_3, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 105; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 105; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_5);
    __pyx_5 = 0;
    __pyx_4 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 105; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    if (PyObject_SetAttr(__pyx_v_self, __pyx_n___list, __pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 105; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    goto __pyx_L3;
  }
  goto __pyx_L1;
  __pyx_L3:;

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":106 */
  __pyx_5 = PyObject_GetAttr(__pyx_v_self, __pyx_n___list); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 106; goto __pyx_L1;}
  __pyx_r = __pyx_5;
  __pyx_5 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("gens.Generators.list");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF((PyObject *)__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_n_assign_names;
static PyObject *__pyx_n_gens;

static PyObject *__pyx_f_4gens_10Generators_objgens(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4gens_10Generators_objgens[] = "\n        Return self and the generators of self as a tuple, possibly re-assigning\n        the names of self.\n\n        INPUT:\n            names -- tuple or string\n\n        OUTPUT:\n            self  -- this object\n            tuple -- self.gens()\n        \n        EXAMPLES:\n            sage: R, x = MPolynomialRing(Q,3).objgens()\n            sage: R\n            Polynomial Ring in x0, x1, x2 over Rational Field\n            sage: x\n            (x0, x1, x2)\n            sage: R, (a,b,c) = R.objgens(\'abc\')\n            sage: a^2 + b^2 + c^2\n            c^2 + b^2 + a^2\n        ";
static PyObject *__pyx_f_4gens_10Generators_objgens(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_names = 0;
  PyObject *__pyx_r;
  int __pyx_1;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  static char *__pyx_argnames[] = {"names",0};
  __pyx_v_names = __pyx_k4;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_names)) return 0;
  Py_INCREF((PyObject *)__pyx_v_self);
  Py_INCREF(__pyx_v_names);

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":130 */
  __pyx_1 = __pyx_v_names == Py_None;
  __pyx_2 = (!__pyx_1);
  if (__pyx_2) {

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":131 */
    __pyx_3 = PyObject_GetAttr(__pyx_v_self, __pyx_n_assign_names); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 131; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 131; goto __pyx_L1;}
    Py_INCREF(__pyx_v_names);
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_names);
    __pyx_5 = PyObject_CallObject(__pyx_3, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 131; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":132 */
  __pyx_3 = PyObject_GetAttr(__pyx_v_self, __pyx_n_gens); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 132; goto __pyx_L1;}
  __pyx_4 = PyTuple_New(0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 132; goto __pyx_L1;}
  __pyx_5 = PyObject_CallObject(__pyx_3, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 132; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 132; goto __pyx_L1;}
  Py_INCREF(__pyx_v_self);
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_self);
  PyTuple_SET_ITEM(__pyx_3, 1, __pyx_5);
  __pyx_5 = 0;
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("gens.Generators.objgens");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF((PyObject *)__pyx_v_self);
  Py_DECREF(__pyx_v_names);
  return __pyx_r;
}

static PyObject *__pyx_n_gen;

static PyObject *__pyx_f_4gens_10Generators_objgen(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4gens_10Generators_objgen[] = "\n        Return self and the generator of self, possibly re-assigning\n        the name of this generator.\n\n        INPUT:\n            names -- tuple or string\n\n        OUTPUT:\n            self  -- this object\n            an object -- self.gen()\n        \n        EXAMPLES:\n            sage: R, x = PolynomialRing(Q).objgen()\n            sage: R\n            Univariate Polynomial Ring in x over Rational Field\n            sage: x\n            x\n            sage: S, a = (R/(x^2+1)).objgen(\'a\')\n            sage: S\n            Univariate Quotient Polynomial Ring in a over Rational Field with modulus x^2 + 1\n        ";
static PyObject *__pyx_f_4gens_10Generators_objgen(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_names = 0;
  PyObject *__pyx_r;
  int __pyx_1;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  static char *__pyx_argnames[] = {"names",0};
  __pyx_v_names = __pyx_k5;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_names)) return 0;
  Py_INCREF((PyObject *)__pyx_v_self);
  Py_INCREF(__pyx_v_names);

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":156 */
  __pyx_1 = __pyx_v_names == Py_None;
  __pyx_2 = (!__pyx_1);
  if (__pyx_2) {

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":157 */
    __pyx_3 = PyObject_GetAttr(__pyx_v_self, __pyx_n_assign_names); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 157; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 157; goto __pyx_L1;}
    Py_INCREF(__pyx_v_names);
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_names);
    __pyx_5 = PyObject_CallObject(__pyx_3, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 157; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":158 */
  __pyx_3 = PyObject_GetAttr(__pyx_v_self, __pyx_n_gen); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 158; goto __pyx_L1;}
  __pyx_4 = PyTuple_New(0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 158; goto __pyx_L1;}
  __pyx_5 = PyObject_CallObject(__pyx_3, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 158; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 158; goto __pyx_L1;}
  Py_INCREF(__pyx_v_self);
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_self);
  PyTuple_SET_ITEM(__pyx_3, 1, __pyx_5);
  __pyx_5 = 0;
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("gens.Generators.objgen");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF((PyObject *)__pyx_v_self);
  Py_DECREF(__pyx_v_names);
  return __pyx_r;
}

static PyObject *__pyx_n___gens;
static PyObject *__pyx_n_ngens;
static PyObject *__pyx_n_append;
static PyObject *__pyx_n_tuple;

static PyObject *__pyx_f_4gens_10Generators_gens(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4gens_10Generators_gens[] = "\n       Return a tuple whose entries are the generators for this\n       object, in order.\n       ";
static PyObject *__pyx_f_4gens_10Generators_gens(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_v_i;
  int __pyx_v_n;
  PyObject *__pyx_v_v;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF((PyObject *)__pyx_v_self);
  __pyx_v_v = Py_None; Py_INCREF(Py_None);

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":166 */
  /*try:*/ {

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":167 */
    __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n___gens); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 167; goto __pyx_L2;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;
  }
  goto __pyx_L3;
  __pyx_L2:;
  Py_XDECREF(__pyx_1); __pyx_1 = 0;

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":168 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_AttributeError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 168; goto __pyx_L1;}
  __pyx_2 = PyErr_ExceptionMatches(__pyx_1);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  if (__pyx_2) {
    __Pyx_AddTraceback("gens.gens");
    __pyx_1 = __Pyx_GetExcValue(); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 168; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":169 */
    __pyx_1 = PyList_New(0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 169; goto __pyx_L1;}
    Py_DECREF(__pyx_v_v);
    __pyx_v_v = __pyx_1;
    __pyx_1 = 0;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":170 */
    __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n_ngens); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 170; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 170; goto __pyx_L1;}
    __pyx_4 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 170; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_2 = PyInt_AsLong(__pyx_4); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 170; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __pyx_v_n = __pyx_2;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":171 */
    for (__pyx_v_i = 0; __pyx_v_i < __pyx_v_n; ++__pyx_v_i) {

      /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":172 */
      __pyx_1 = PyObject_GetAttr(__pyx_v_v, __pyx_n_append); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 172; goto __pyx_L1;}
      __pyx_3 = PyObject_GetAttr(__pyx_v_self, __pyx_n_gen); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 172; goto __pyx_L1;}
      __pyx_4 = PyInt_FromLong(__pyx_v_i); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 172; goto __pyx_L1;}
      __pyx_5 = PyTuple_New(1); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 172; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_5, 0, __pyx_4);
      __pyx_4 = 0;
      __pyx_4 = PyObject_CallObject(__pyx_3, __pyx_5); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 172; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 172; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_4);
      __pyx_4 = 0;
      __pyx_5 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 172; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      __pyx_L4:;
    }
    __pyx_L5:;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":173 */
    __pyx_4 = __Pyx_GetName(__pyx_b, __pyx_n_tuple); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 173; goto __pyx_L1;}
    __pyx_1 = PyTuple_New(1); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 173; goto __pyx_L1;}
    Py_INCREF(__pyx_v_v);
    PyTuple_SET_ITEM(__pyx_1, 0, __pyx_v_v);
    __pyx_3 = PyObject_CallObject(__pyx_4, __pyx_1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 173; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    if (PyObject_SetAttr(__pyx_v_self, __pyx_n___gens, __pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 173; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":174 */
    __pyx_5 = PyObject_GetAttr(__pyx_v_self, __pyx_n___gens); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 174; goto __pyx_L1;}
    __pyx_r = __pyx_5;
    __pyx_5 = 0;
    goto __pyx_L0;
    goto __pyx_L3;
  }
  goto __pyx_L1;
  __pyx_L3:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("gens.Generators.gens");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_v);
  Py_DECREF((PyObject *)__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_n___gens_dict;
static PyObject *__pyx_n_str;

static PyObject *__pyx_f_4gens_10Generators_gens_dict(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4gens_10Generators_gens_dict[] = "\n        Return a dictionary whose entries are \\code{var_name:variable}.\n        ";
static PyObject *__pyx_f_4gens_10Generators_gens_dict(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_v;
  PyObject *__pyx_v_x;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF((PyObject *)__pyx_v_self);
  __pyx_v_v = Py_None; Py_INCREF(Py_None);
  __pyx_v_x = Py_None; Py_INCREF(Py_None);

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":180 */
  /*try:*/ {

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":181 */
    __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n___gens_dict); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 181; goto __pyx_L2;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;
  }
  goto __pyx_L3;
  __pyx_L2:;
  Py_XDECREF(__pyx_1); __pyx_1 = 0;

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":182 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_AttributeError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 182; goto __pyx_L1;}
  __pyx_2 = PyErr_ExceptionMatches(__pyx_1);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  if (__pyx_2) {
    __Pyx_AddTraceback("gens.gens_dict");
    __pyx_1 = __Pyx_GetExcValue(); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 182; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":183 */
    __pyx_1 = PyDict_New(); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 183; goto __pyx_L1;}
    Py_DECREF(__pyx_v_v);
    __pyx_v_v = __pyx_1;
    __pyx_1 = 0;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":184 */
    __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n_gens); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 184; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 184; goto __pyx_L1;}
    __pyx_4 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 184; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_1 = PyObject_GetIter(__pyx_4); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 184; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    for (;;) {
      __pyx_L4:;
      __pyx_3 = PyIter_Next(__pyx_1);
      if (!__pyx_3) {
        if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 184; goto __pyx_L1;}
        break;
      }
      Py_DECREF(__pyx_v_x);
      __pyx_v_x = __pyx_3;
      __pyx_3 = 0;

      /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":185 */
      __pyx_4 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 185; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 185; goto __pyx_L1;}
      Py_INCREF(__pyx_v_x);
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_x);
      __pyx_5 = PyObject_CallObject(__pyx_4, __pyx_3); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 185; goto __pyx_L1;}
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      if (PyObject_SetItem(__pyx_v_v, __pyx_5, __pyx_v_x) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 185; goto __pyx_L1;}
      Py_DECREF(__pyx_5); __pyx_5 = 0;
    }
    __pyx_L5:;
    Py_DECREF(__pyx_1); __pyx_1 = 0;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":186 */
    if (PyObject_SetAttr(__pyx_v_self, __pyx_n___gens_dict, __pyx_v_v) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 186; goto __pyx_L1;}

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":187 */
    Py_INCREF(__pyx_v_v);
    __pyx_r = __pyx_v_v;
    goto __pyx_L0;
    goto __pyx_L3;
  }
  goto __pyx_L1;
  __pyx_L3:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("gens.Generators.gens_dict");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_v);
  Py_DECREF(__pyx_v_x);
  Py_DECREF((PyObject *)__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_n_isinstance;
static PyObject *__pyx_n_TypeError;
static PyObject *__pyx_n_strip;
static PyObject *__pyx_n_ValueError;
static PyObject *__pyx_n_isalnum;

static PyObject *__pyx_k11p;
static PyObject *__pyx_k12p;
static PyObject *__pyx_k13p;

static char (__pyx_k11[]) = "variable name must be a string but %s isn't";
static char (__pyx_k12[]) = "variable name must be nonempty";
static char (__pyx_k13[]) = "variable names must be alphanumeric, but one is '%s' which is not.";

static PyObject *__pyx_f_4gens_10Generators___certify_names(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_4gens_10Generators___certify_names(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_names = 0;
  PyObject *__pyx_v_v;
  PyObject *__pyx_v_N;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  int __pyx_5;
  int __pyx_6;
  static char *__pyx_argnames[] = {"names",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_names)) return 0;
  Py_INCREF((PyObject *)__pyx_v_self);
  Py_INCREF(__pyx_v_names);
  __pyx_v_v = Py_None; Py_INCREF(Py_None);
  __pyx_v_N = Py_None; Py_INCREF(Py_None);

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":190 */
  __pyx_1 = PyList_New(0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 190; goto __pyx_L1;}
  Py_DECREF(__pyx_v_v);
  __pyx_v_v = __pyx_1;
  __pyx_1 = 0;

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":191 */
  __pyx_1 = PyObject_GetIter(__pyx_v_names); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 191; goto __pyx_L1;}
  for (;;) {
    __pyx_L2:;
    __pyx_2 = PyIter_Next(__pyx_1);
    if (!__pyx_2) {
      if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 191; goto __pyx_L1;}
      break;
    }
    Py_DECREF(__pyx_v_N);
    __pyx_v_N = __pyx_2;
    __pyx_2 = 0;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":192 */
    __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_isinstance); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 192; goto __pyx_L1;}
    __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 192; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 192; goto __pyx_L1;}
    Py_INCREF(__pyx_v_N);
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_N);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_3);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 192; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __pyx_5 = PyObject_IsTrue(__pyx_3); if (__pyx_5 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 192; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_6 = (!__pyx_5);
    if (__pyx_6) {

      /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":193 */
      __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 193; goto __pyx_L1;}
      __pyx_4 = PyNumber_Remainder(__pyx_k11p, __pyx_v_N); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 193; goto __pyx_L1;}
      __Pyx_Raise(__pyx_2, __pyx_4, 0);
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 193; goto __pyx_L1;}
      goto __pyx_L4;
    }
    __pyx_L4:;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":194 */
    __pyx_3 = PyObject_GetAttr(__pyx_v_N, __pyx_n_strip); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 194; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 194; goto __pyx_L1;}
    __pyx_4 = PyObject_CallObject(__pyx_3, __pyx_2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 194; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_v_N);
    __pyx_v_N = __pyx_4;
    __pyx_4 = 0;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":195 */
    __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_len); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 195; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 195; goto __pyx_L1;}
    Py_INCREF(__pyx_v_N);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_N);
    __pyx_4 = PyObject_CallObject(__pyx_3, __pyx_2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 195; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_3 = PyInt_FromLong(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 195; goto __pyx_L1;}
    if (PyObject_Cmp(__pyx_4, __pyx_3, &__pyx_5) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 195; goto __pyx_L1;}
    __pyx_5 = __pyx_5 == 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    if (__pyx_5) {

      /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":196 */
      __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_ValueError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 196; goto __pyx_L1;}
      __Pyx_Raise(__pyx_2, __pyx_k12p, 0);
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 196; goto __pyx_L1;}
      goto __pyx_L5;
    }
    __pyx_L5:;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":197 */
    __pyx_4 = PyObject_GetAttr(__pyx_v_N, __pyx_n_isalnum); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 197; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 197; goto __pyx_L1;}
    __pyx_2 = PyObject_CallObject(__pyx_4, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 197; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_6 = PyObject_IsTrue(__pyx_2); if (__pyx_6 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 197; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_5 = (!__pyx_6);
    if (__pyx_5) {

      /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":198 */
      __pyx_4 = __Pyx_GetName(__pyx_b, __pyx_n_ValueError); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 198; goto __pyx_L1;}
      __pyx_3 = PyNumber_Remainder(__pyx_k13p, __pyx_v_N); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 198; goto __pyx_L1;}
      __Pyx_Raise(__pyx_4, __pyx_3, 0);
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 198; goto __pyx_L1;}
      goto __pyx_L6;
    }
    __pyx_L6:;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":199 */
    __pyx_2 = PyObject_GetAttr(__pyx_v_v, __pyx_n_append); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 199; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 199; goto __pyx_L1;}
    Py_INCREF(__pyx_v_N);
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_N);
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 199; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
  }
  __pyx_L3:;
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":200 */
  __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_tuple); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 200; goto __pyx_L1;}
  __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 200; goto __pyx_L1;}
  Py_INCREF(__pyx_v_v);
  PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_v);
  __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 200; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("gens.Generators.__certify_names");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_v);
  Py_DECREF(__pyx_v_N);
  Py_DECREF((PyObject *)__pyx_v_self);
  Py_DECREF(__pyx_v_names);
  return __pyx_r;
}

static PyObject *__pyx_n_find;
static PyObject *__pyx_n_split;
static PyObject *__pyx_n_misc;
static PyObject *__pyx_n_defaults;
static PyObject *__pyx_n_variable_names;
static PyObject *__pyx_n___certify_names;
static PyObject *__pyx_n_latex_variable_names;
static PyObject *__pyx_n_IndexError;
static PyObject *__pyx_n___names;
static PyObject *__pyx_n___latex_names;

static PyObject *__pyx_k14p;
static PyObject *__pyx_k15p;
static PyObject *__pyx_k16p;
static PyObject *__pyx_k17p;
static PyObject *__pyx_k18p;

static char (__pyx_k14[]) = ",";
static char (__pyx_k15[]) = ",";
static char (__pyx_k16[]) = "names must be a list or tuple of strings";
static char (__pyx_k17[]) = "names must consist of strings";
static char (__pyx_k18[]) = "the number of names must equal the number of generators";

static PyObject *__pyx_f_4gens_10Generators_assign_names(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_4gens_10Generators_assign_names(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_names = 0;
  PyObject *__pyx_v_name;
  PyObject *__pyx_v_latex_names;
  PyObject *__pyx_v_x;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  PyObject *__pyx_6 = 0;
  int __pyx_7;
  static char *__pyx_argnames[] = {"names",0};
  __pyx_v_names = __pyx_k6;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_names)) return 0;
  Py_INCREF((PyObject *)__pyx_v_self);
  Py_INCREF(__pyx_v_names);
  __pyx_v_name = Py_None; Py_INCREF(Py_None);
  __pyx_v_latex_names = Py_None; Py_INCREF(Py_None);
  __pyx_v_x = Py_None; Py_INCREF(Py_None);

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":203 */
  __pyx_1 = __pyx_v_names == Py_None;
  if (__pyx_1) {
    __pyx_r = Py_None; Py_INCREF(Py_None);
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":204 */
  __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_isinstance); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 204; goto __pyx_L1;}
  __pyx_4 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 204; goto __pyx_L1;}
  __pyx_5 = PyTuple_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 204; goto __pyx_L1;}
  Py_INCREF(__pyx_v_names);
  PyTuple_SET_ITEM(__pyx_5, 0, __pyx_v_names);
  PyTuple_SET_ITEM(__pyx_5, 1, __pyx_4);
  __pyx_4 = 0;
  __pyx_2 = PyObject_CallObject(__pyx_3, __pyx_5); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 204; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  Py_DECREF(__pyx_5); __pyx_5 = 0;
  __pyx_1 = PyObject_IsTrue(__pyx_2); if (__pyx_1 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 204; goto __pyx_L1;}
  if (__pyx_1) {
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_4 = PyObject_GetAttr(__pyx_v_names, __pyx_n_find); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 204; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 204; goto __pyx_L1;}
    Py_INCREF(__pyx_k14p);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_k14p);
    __pyx_5 = PyObject_CallObject(__pyx_4, __pyx_3); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 204; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_4 = PyInt_FromLong((-1)); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 204; goto __pyx_L1;}
    if (PyObject_Cmp(__pyx_5, __pyx_4, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 204; goto __pyx_L1;}
    __pyx_1 = __pyx_1 != 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __pyx_2 = PyInt_FromLong(__pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 204; goto __pyx_L1;}
  }
  __pyx_1 = PyObject_IsTrue(__pyx_2); if (__pyx_1 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 204; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (__pyx_1) {

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":205 */
    __pyx_3 = PyObject_GetAttr(__pyx_v_names, __pyx_n_split); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 205; goto __pyx_L1;}
    __pyx_5 = PyTuple_New(1); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 205; goto __pyx_L1;}
    Py_INCREF(__pyx_k15p);
    PyTuple_SET_ITEM(__pyx_5, 0, __pyx_k15p);
    __pyx_4 = PyObject_CallObject(__pyx_3, __pyx_5); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 205; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    Py_DECREF(__pyx_v_names);
    __pyx_v_names = __pyx_4;
    __pyx_4 = 0;
    goto __pyx_L3;
  }
  __pyx_L3:;

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":206 */
  __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_isinstance); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 206; goto __pyx_L1;}
  __pyx_5 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 206; goto __pyx_L1;}
  __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 206; goto __pyx_L1;}
  Py_INCREF(__pyx_v_names);
  PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_names);
  PyTuple_SET_ITEM(__pyx_4, 1, __pyx_5);
  __pyx_5 = 0;
  __pyx_2 = PyObject_CallObject(__pyx_3, __pyx_4); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 206; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  __pyx_1 = PyObject_IsTrue(__pyx_2); if (__pyx_1 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 206; goto __pyx_L1;}
  if (__pyx_1) {
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_5 = PyObject_GetAttr(__pyx_v_self, __pyx_n_ngens); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 206; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 206; goto __pyx_L1;}
    __pyx_4 = PyObject_CallObject(__pyx_5, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 206; goto __pyx_L1;}
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_5 = PyInt_FromLong(1); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 206; goto __pyx_L1;}
    if (PyObject_Cmp(__pyx_4, __pyx_5, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 206; goto __pyx_L1;}
    __pyx_1 = __pyx_1 > 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    if (__pyx_1) {
      __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_len); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 206; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 206; goto __pyx_L1;}
      Py_INCREF(__pyx_v_names);
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_names);
      __pyx_5 = PyObject_CallObject(__pyx_3, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 206; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      __pyx_3 = PyObject_GetAttr(__pyx_v_self, __pyx_n_ngens); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 206; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 206; goto __pyx_L1;}
      __pyx_6 = PyObject_CallObject(__pyx_3, __pyx_4); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 206; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      if (PyObject_Cmp(__pyx_5, __pyx_6, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 206; goto __pyx_L1;}
      __pyx_1 = __pyx_1 == 0;
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      Py_DECREF(__pyx_6); __pyx_6 = 0;
    }
    __pyx_2 = PyInt_FromLong(__pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 206; goto __pyx_L1;}
  }
  __pyx_1 = PyObject_IsTrue(__pyx_2); if (__pyx_1 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 206; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (__pyx_1) {

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":207 */
    __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_tuple); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 207; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 207; goto __pyx_L1;}
    Py_INCREF(__pyx_v_names);
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_names);
    __pyx_5 = PyObject_CallObject(__pyx_3, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 207; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_v_names);
    __pyx_v_names = __pyx_5;
    __pyx_5 = 0;
    goto __pyx_L4;
  }
  __pyx_L4:;

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":208 */
  __pyx_6 = __Pyx_GetName(__pyx_b, __pyx_n_isinstance); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 208; goto __pyx_L1;}
  __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 208; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 208; goto __pyx_L1;}
  Py_INCREF(__pyx_v_names);
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_names);
  PyTuple_SET_ITEM(__pyx_3, 1, __pyx_2);
  __pyx_2 = 0;
  __pyx_4 = PyObject_CallObject(__pyx_6, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 208; goto __pyx_L1;}
  Py_DECREF(__pyx_6); __pyx_6 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_1 = PyObject_IsTrue(__pyx_4); if (__pyx_1 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 208; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  if (__pyx_1) {

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":209 */
    Py_INCREF(__pyx_v_names);
    Py_DECREF(__pyx_v_name);
    __pyx_v_name = __pyx_v_names;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":210 */
    __pyx_5 = __Pyx_GetName(__pyx_m, __pyx_n_sage); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 210; goto __pyx_L1;}
    __pyx_2 = PyObject_GetAttr(__pyx_5, __pyx_n_misc); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 210; goto __pyx_L1;}
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    __pyx_6 = PyObject_GetAttr(__pyx_2, __pyx_n_defaults); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 210; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_3 = PyObject_GetAttr(__pyx_6, __pyx_n_variable_names); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 210; goto __pyx_L1;}
    Py_DECREF(__pyx_6); __pyx_6 = 0;
    __pyx_4 = PyObject_GetAttr(__pyx_v_self, __pyx_n_ngens); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 210; goto __pyx_L1;}
    __pyx_5 = PyTuple_New(0); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 210; goto __pyx_L1;}
    __pyx_2 = PyObject_CallObject(__pyx_4, __pyx_5); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 210; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    __pyx_6 = PyTuple_New(2); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 210; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_6, 0, __pyx_2);
    Py_INCREF(__pyx_v_name);
    PyTuple_SET_ITEM(__pyx_6, 1, __pyx_v_name);
    __pyx_2 = 0;
    __pyx_4 = PyObject_CallObject(__pyx_3, __pyx_6); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 210; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_6); __pyx_6 = 0;
    Py_DECREF(__pyx_v_names);
    __pyx_v_names = __pyx_4;
    __pyx_4 = 0;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":211 */
    __pyx_5 = PyObject_GetAttr(__pyx_v_self, __pyx_n___certify_names); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 211; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 211; goto __pyx_L1;}
    Py_INCREF(__pyx_v_names);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_names);
    __pyx_3 = PyObject_CallObject(__pyx_5, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 211; goto __pyx_L1;}
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_v_names);
    __pyx_v_names = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":212 */
    __pyx_6 = __Pyx_GetName(__pyx_m, __pyx_n_sage); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 212; goto __pyx_L1;}
    __pyx_4 = PyObject_GetAttr(__pyx_6, __pyx_n_misc); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 212; goto __pyx_L1;}
    Py_DECREF(__pyx_6); __pyx_6 = 0;
    __pyx_5 = PyObject_GetAttr(__pyx_4, __pyx_n_defaults); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 212; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __pyx_2 = PyObject_GetAttr(__pyx_5, __pyx_n_latex_variable_names); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 212; goto __pyx_L1;}
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    __pyx_3 = PyObject_GetAttr(__pyx_v_self, __pyx_n_ngens); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 212; goto __pyx_L1;}
    __pyx_6 = PyTuple_New(0); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 212; goto __pyx_L1;}
    __pyx_4 = PyObject_CallObject(__pyx_3, __pyx_6); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 212; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_6); __pyx_6 = 0;
    __pyx_5 = PyTuple_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 212; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_5, 0, __pyx_4);
    Py_INCREF(__pyx_v_name);
    PyTuple_SET_ITEM(__pyx_5, 1, __pyx_v_name);
    __pyx_4 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_5); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 212; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    Py_DECREF(__pyx_v_latex_names);
    __pyx_v_latex_names = __pyx_3;
    __pyx_3 = 0;
    goto __pyx_L5;
  }
  /*else*/ {

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":214 */
    __pyx_6 = PyObject_GetAttr(__pyx_v_self, __pyx_n___certify_names); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 214; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 214; goto __pyx_L1;}
    Py_INCREF(__pyx_v_names);
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_names);
    __pyx_2 = PyObject_CallObject(__pyx_6, __pyx_4); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 214; goto __pyx_L1;}
    Py_DECREF(__pyx_6); __pyx_6 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_v_names);
    __pyx_v_names = __pyx_2;
    __pyx_2 = 0;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":215 */
    __pyx_5 = __Pyx_GetName(__pyx_b, __pyx_n_isinstance); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 215; goto __pyx_L1;}
    __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_list); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 215; goto __pyx_L1;}
    __pyx_6 = __Pyx_GetName(__pyx_b, __pyx_n_tuple); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 215; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 215; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_6);
    __pyx_3 = 0;
    __pyx_6 = 0;
    __pyx_2 = PyTuple_New(2); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 215; goto __pyx_L1;}
    Py_INCREF(__pyx_v_names);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_names);
    PyTuple_SET_ITEM(__pyx_2, 1, __pyx_4);
    __pyx_4 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_5, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 215; goto __pyx_L1;}
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_1 = PyObject_IsTrue(__pyx_3); if (__pyx_1 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 215; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_7 = (!__pyx_1);
    if (__pyx_7) {

      /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":216 */
      __pyx_6 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 216; goto __pyx_L1;}
      __Pyx_Raise(__pyx_6, __pyx_k16p, 0);
      Py_DECREF(__pyx_6); __pyx_6 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 216; goto __pyx_L1;}
      goto __pyx_L6;
    }
    __pyx_L6:;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":217 */
    __pyx_4 = PyObject_GetIter(__pyx_v_names); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 217; goto __pyx_L1;}
    for (;;) {
      __pyx_L7:;
      __pyx_5 = PyIter_Next(__pyx_4);
      if (!__pyx_5) {
        if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 217; goto __pyx_L1;}
        break;
      }
      Py_DECREF(__pyx_v_x);
      __pyx_v_x = __pyx_5;
      __pyx_5 = 0;

      /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":218 */
      __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_isinstance); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 218; goto __pyx_L1;}
      __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 218; goto __pyx_L1;}
      __pyx_6 = PyTuple_New(2); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 218; goto __pyx_L1;}
      Py_INCREF(__pyx_v_x);
      PyTuple_SET_ITEM(__pyx_6, 0, __pyx_v_x);
      PyTuple_SET_ITEM(__pyx_6, 1, __pyx_3);
      __pyx_3 = 0;
      __pyx_5 = PyObject_CallObject(__pyx_2, __pyx_6); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 218; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_6); __pyx_6 = 0;
      __pyx_1 = PyObject_IsTrue(__pyx_5); if (__pyx_1 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 218; goto __pyx_L1;}
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      __pyx_7 = (!__pyx_1);
      if (__pyx_7) {

        /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":219 */
        __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 219; goto __pyx_L1;}
        __Pyx_Raise(__pyx_3, __pyx_k17p, 0);
        Py_DECREF(__pyx_3); __pyx_3 = 0;
        {__pyx_filename = __pyx_f[0]; __pyx_lineno = 219; goto __pyx_L1;}
        goto __pyx_L9;
      }
      __pyx_L9:;
    }
    __pyx_L8:;
    Py_DECREF(__pyx_4); __pyx_4 = 0;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":220 */
    __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_len); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 220; goto __pyx_L1;}
    __pyx_6 = PyTuple_New(1); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 220; goto __pyx_L1;}
    Py_INCREF(__pyx_v_names);
    PyTuple_SET_ITEM(__pyx_6, 0, __pyx_v_names);
    __pyx_5 = PyObject_CallObject(__pyx_2, __pyx_6); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 220; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_6); __pyx_6 = 0;
    __pyx_3 = PyObject_GetAttr(__pyx_v_self, __pyx_n_ngens); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 220; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 220; goto __pyx_L1;}
    __pyx_2 = PyObject_CallObject(__pyx_3, __pyx_4); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 220; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    if (PyObject_Cmp(__pyx_5, __pyx_2, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 220; goto __pyx_L1;}
    __pyx_1 = __pyx_1 != 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (__pyx_1) {

      /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":221 */
      __pyx_6 = __Pyx_GetName(__pyx_b, __pyx_n_IndexError); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 221; goto __pyx_L1;}
      __Pyx_Raise(__pyx_6, __pyx_k18p, 0);
      Py_DECREF(__pyx_6); __pyx_6 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 221; goto __pyx_L1;}
      goto __pyx_L10;
    }
    __pyx_L10:;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":222 */
    Py_INCREF(__pyx_v_names);
    Py_DECREF(__pyx_v_latex_names);
    __pyx_v_latex_names = __pyx_v_names;
  }
  __pyx_L5:;

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":223 */
  __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_tuple); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 223; goto __pyx_L1;}
  __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 223; goto __pyx_L1;}
  Py_INCREF(__pyx_v_names);
  PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_names);
  __pyx_5 = PyObject_CallObject(__pyx_3, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 223; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  if (PyObject_SetAttr(__pyx_v_self, __pyx_n___names, __pyx_5) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 223; goto __pyx_L1;}
  Py_DECREF(__pyx_5); __pyx_5 = 0;

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":224 */
  __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_tuple); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 224; goto __pyx_L1;}
  __pyx_6 = PyTuple_New(1); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 224; goto __pyx_L1;}
  Py_INCREF(__pyx_v_latex_names);
  PyTuple_SET_ITEM(__pyx_6, 0, __pyx_v_latex_names);
  __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_6); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 224; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_6); __pyx_6 = 0;
  if (PyObject_SetAttr(__pyx_v_self, __pyx_n___latex_names, __pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 224; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  Py_XDECREF(__pyx_6);
  __Pyx_AddTraceback("gens.Generators.assign_names");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_name);
  Py_DECREF(__pyx_v_latex_names);
  Py_DECREF(__pyx_v_x);
  Py_DECREF((PyObject *)__pyx_v_self);
  Py_DECREF(__pyx_v_names);
  return __pyx_r;
}

static PyObject *__pyx_f_4gens_10Generators__names_from_obj(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_4gens_10Generators__names_from_obj(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_X = 0;
  PyObject *__pyx_v_old;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  int __pyx_5;
  static char *__pyx_argnames[] = {"X",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_X)) return 0;
  Py_INCREF((PyObject *)__pyx_v_self);
  Py_INCREF(__pyx_v_X);
  __pyx_v_old = Py_None; Py_INCREF(Py_None);

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":227 */
  /*try:*/ {

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":228 */
    __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n___names); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 228; goto __pyx_L2;}
    __pyx_2 = PyObject_GetAttr(__pyx_v_self, __pyx_n___latex_names); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 228; goto __pyx_L2;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 228; goto __pyx_L2;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_1);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_2);
    __pyx_1 = 0;
    __pyx_2 = 0;
    Py_DECREF(__pyx_v_old);
    __pyx_v_old = __pyx_3;
    __pyx_3 = 0;
  }
  goto __pyx_L3;
  __pyx_L2:;
  Py_XDECREF(__pyx_1); __pyx_1 = 0;
  Py_XDECREF(__pyx_2); __pyx_2 = 0;
  Py_XDECREF(__pyx_3); __pyx_3 = 0;

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":229 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_AttributeError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 229; goto __pyx_L1;}
  __pyx_4 = PyErr_ExceptionMatches(__pyx_1);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  if (__pyx_4) {
    __Pyx_AddTraceback("gens._names_from_obj");
    __pyx_2 = __Pyx_GetExcValue(); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 229; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":230 */
    Py_INCREF(Py_None);
    Py_DECREF(__pyx_v_old);
    __pyx_v_old = Py_None;
    goto __pyx_L3;
  }
  goto __pyx_L1;
  __pyx_L3:;

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":231 */
  /*try:*/ {

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":232 */
    __pyx_4 = __pyx_v_X == Py_None;
    if (__pyx_4) {

      /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":233 */
      if (PyObject_DelAttr(__pyx_v_self, __pyx_n___names) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 233; goto __pyx_L4;}

      /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":234 */
      if (PyObject_DelAttr(__pyx_v_self, __pyx_n___latex_names) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 234; goto __pyx_L4;}

      /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":235 */
      Py_INCREF(__pyx_v_old);
      __pyx_r = __pyx_v_old;
      goto __pyx_L0;
      goto __pyx_L6;
    }
    __pyx_L6:;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":236 */
    __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_isinstance); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 236; goto __pyx_L4;}
    __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_tuple); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 236; goto __pyx_L4;}
    __pyx_2 = PyTuple_New(2); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 236; goto __pyx_L4;}
    Py_INCREF(__pyx_v_X);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_X);
    PyTuple_SET_ITEM(__pyx_2, 1, __pyx_1);
    __pyx_1 = 0;
    __pyx_1 = PyObject_CallObject(__pyx_3, __pyx_2); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 236; goto __pyx_L4;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_4 = PyObject_IsTrue(__pyx_1); if (__pyx_4 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 236; goto __pyx_L4;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    __pyx_5 = (!__pyx_4);
    if (__pyx_5) {

      /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":237 */
      __pyx_3 = PyObject_GetAttr(__pyx_v_X, __pyx_n___names); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 237; goto __pyx_L4;}
      __pyx_2 = PyObject_GetAttr(__pyx_v_X, __pyx_n___latex_names); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 237; goto __pyx_L4;}
      __pyx_1 = PyTuple_New(2); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 237; goto __pyx_L4;}
      PyTuple_SET_ITEM(__pyx_1, 0, __pyx_3);
      PyTuple_SET_ITEM(__pyx_1, 1, __pyx_2);
      __pyx_3 = 0;
      __pyx_2 = 0;
      Py_DECREF(__pyx_v_X);
      __pyx_v_X = __pyx_1;
      __pyx_1 = 0;
      goto __pyx_L7;
    }
    __pyx_L7:;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":238 */
    __pyx_3 = __Pyx_UnpackItem(__pyx_v_X, 0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 238; goto __pyx_L4;}
    if (PyObject_SetAttr(__pyx_v_self, __pyx_n___names, __pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 238; goto __pyx_L4;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_2 = __Pyx_UnpackItem(__pyx_v_X, 1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 238; goto __pyx_L4;}
    if (PyObject_SetAttr(__pyx_v_self, __pyx_n___latex_names, __pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 238; goto __pyx_L4;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (__Pyx_EndUnpack(__pyx_v_X, 2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 238; goto __pyx_L4;}
  }
  goto __pyx_L5;
  __pyx_L4:;
  Py_XDECREF(__pyx_1); __pyx_1 = 0;
  Py_XDECREF(__pyx_3); __pyx_3 = 0;
  Py_XDECREF(__pyx_2); __pyx_2 = 0;

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":239 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_AttributeError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 239; goto __pyx_L1;}
  __pyx_4 = PyErr_ExceptionMatches(__pyx_1);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  if (__pyx_4) {
    __Pyx_AddTraceback("gens._names_from_obj");
    __pyx_3 = __Pyx_GetExcValue(); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 239; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":240 */
    goto __pyx_L5;
  }
  goto __pyx_L1;
  __pyx_L5:;

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":241 */
  Py_INCREF(__pyx_v_old);
  __pyx_r = __pyx_v_old;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("gens.Generators._names_from_obj");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_old);
  Py_DECREF((PyObject *)__pyx_v_self);
  Py_DECREF(__pyx_v_X);
  return __pyx_r;
}

static PyObject *__pyx_f_4gens_10Generators_variable_names(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_4gens_10Generators_variable_names(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF((PyObject *)__pyx_v_self);

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":244 */
  /*try:*/ {

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":245 */
    __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n___names); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 245; goto __pyx_L2;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;
  }
  goto __pyx_L3;
  __pyx_L2:;
  Py_XDECREF(__pyx_1); __pyx_1 = 0;

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":246 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_AttributeError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 246; goto __pyx_L1;}
  __pyx_2 = PyErr_ExceptionMatches(__pyx_1);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  if (__pyx_2) {
    __Pyx_AddTraceback("gens.variable_names");
    __pyx_1 = __Pyx_GetExcValue(); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 246; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":247 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_sage); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 247; goto __pyx_L1;}
    __pyx_3 = PyObject_GetAttr(__pyx_1, __pyx_n_misc); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 247; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    __pyx_1 = PyObject_GetAttr(__pyx_3, __pyx_n_defaults); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 247; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_3 = PyObject_GetAttr(__pyx_1, __pyx_n_variable_names); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 247; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n_ngens); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 247; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 247; goto __pyx_L1;}
    __pyx_5 = PyObject_CallObject(__pyx_1, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 247; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __pyx_1 = PyTuple_New(1); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 247; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_1, 0, __pyx_5);
    __pyx_5 = 0;
    __pyx_4 = PyObject_CallObject(__pyx_3, __pyx_1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 247; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    if (PyObject_SetAttr(__pyx_v_self, __pyx_n___names, __pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 247; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":248 */
    __pyx_5 = PyObject_GetAttr(__pyx_v_self, __pyx_n___names); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 248; goto __pyx_L1;}
    __pyx_r = __pyx_5;
    __pyx_5 = 0;
    goto __pyx_L0;
    goto __pyx_L3;
  }
  goto __pyx_L1;
  __pyx_L3:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("gens.Generators.variable_names");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF((PyObject *)__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_4gens_10Generators_latex_variable_names(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_4gens_10Generators_latex_variable_names(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF((PyObject *)__pyx_v_self);

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":251 */
  /*try:*/ {

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":252 */
    __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n___latex_names); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 252; goto __pyx_L2;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;
  }
  goto __pyx_L3;
  __pyx_L2:;
  Py_XDECREF(__pyx_1); __pyx_1 = 0;

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":253 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_AttributeError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 253; goto __pyx_L1;}
  __pyx_2 = PyErr_ExceptionMatches(__pyx_1);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  if (__pyx_2) {
    __Pyx_AddTraceback("gens.latex_variable_names");
    __pyx_1 = __Pyx_GetExcValue(); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 253; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":254 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_sage); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 254; goto __pyx_L1;}
    __pyx_3 = PyObject_GetAttr(__pyx_1, __pyx_n_misc); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 254; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    __pyx_1 = PyObject_GetAttr(__pyx_3, __pyx_n_defaults); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 254; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_3 = PyObject_GetAttr(__pyx_1, __pyx_n_latex_variable_names); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 254; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n_ngens); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 254; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 254; goto __pyx_L1;}
    __pyx_5 = PyObject_CallObject(__pyx_1, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 254; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __pyx_1 = PyTuple_New(1); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 254; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_1, 0, __pyx_5);
    __pyx_5 = 0;
    __pyx_4 = PyObject_CallObject(__pyx_3, __pyx_1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 254; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    if (PyObject_SetAttr(__pyx_v_self, __pyx_n___latex_names, __pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 254; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":255 */
    __pyx_5 = PyObject_GetAttr(__pyx_v_self, __pyx_n___latex_names); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 255; goto __pyx_L1;}
    __pyx_r = __pyx_5;
    __pyx_5 = 0;
    goto __pyx_L0;
    goto __pyx_L3;
  }
  goto __pyx_L1;
  __pyx_L3:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("gens.Generators.latex_variable_names");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF((PyObject *)__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_4gens_10Generators_variable_name(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_4gens_10Generators_variable_name(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF((PyObject *)__pyx_v_self);

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":258 */
  __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n_variable_names); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 258; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 258; goto __pyx_L1;}
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 258; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_1 = PyInt_FromLong(0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 258; goto __pyx_L1;}
  __pyx_2 = PyObject_GetItem(__pyx_3, __pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 258; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("gens.Generators.variable_name");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF((PyObject *)__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_n_variable_name;

static PyObject *__pyx_f_4gens_10Generators_latex_name(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_4gens_10Generators_latex_name(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF((PyObject *)__pyx_v_self);

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":262 */
  __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n_variable_name); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 262; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 262; goto __pyx_L1;}
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 262; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("gens.Generators.latex_name");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF((PyObject *)__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_k19p;

static char (__pyx_k19[]) = "Verification of correctness of homomorphisms from %s not yet implmented.";

static PyObject *__pyx_f_4gens_10Generators__is_valid_homomorphism_(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4gens_10Generators__is_valid_homomorphism_[] = "\n        Return True if \\code{im_gens} defines a valid homomorphism\n        from self to codomain; otherwise return False.\n\n        If determining whether or not a homomorphism is valid has not\n        been implemented for this ring, then a NotImplementedError exception\n        is raised.\n        ";
static PyObject *__pyx_f_4gens_10Generators__is_valid_homomorphism_(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_codomain = 0;
  PyObject *__pyx_v_im_gens = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {"codomain","im_gens",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO", __pyx_argnames, &__pyx_v_codomain, &__pyx_v_im_gens)) return 0;
  Py_INCREF((PyObject *)__pyx_v_self);
  Py_INCREF(__pyx_v_codomain);
  Py_INCREF(__pyx_v_im_gens);

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":277 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 277; goto __pyx_L1;}
  __pyx_2 = PyNumber_Remainder(__pyx_k19p, __pyx_v_self); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 277; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, __pyx_2, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 277; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("gens.Generators._is_valid_homomorphism_");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF((PyObject *)__pyx_v_self);
  Py_DECREF(__pyx_v_codomain);
  Py_DECREF(__pyx_v_im_gens);
  return __pyx_r;
}

static PyObject *__pyx_n_Hom;
static PyObject *__pyx_n_natural_map;
static PyObject *__pyx_n_Sequence;
static PyObject *__pyx_n_universe;
static PyObject *__pyx_n_check;

static PyObject *__pyx_k20p;

static char (__pyx_k20[]) = "sage.structure.all";

static PyObject *__pyx_f_4gens_10Generators_hom(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_4gens_10Generators_hom[] = "\n        Return the unique homomorphism from self to codomain that\n        sends \\code{self.gens()} to the entries of \\code{im_gens}.\n        Raises a TypeError if there is no such homomorphism.\n\n        INPUT:\n            im_gens -- the images in the codomain of the generators of\n                       this object under the homomorphism\n            codomain -- the codomain of the homomorphism\n            check -- whether to verify that the images of generators extend\n                     to define a map (using only canonical coercisions).\n\n        OUTPUT:\n            a homomorphism self --> codomain\n\n        \\note{As a shortcut, one can also give an object X instead of\n        \\code{im_gens}, in which case return the (if it exists)\n        natural map to X.}\n\n        EXAMPLE: Polynomial Ring\n        We first illustrate construction of a few homomorphisms\n        involving a polynomial ring.\n        \n            sage: R, x = PolynomialRing(ZZ).objgen()\n            sage: f = R.hom([5], QQ)\n            sage: f(x^2 - 19)\n            6\n\n            sage: R, x = PolynomialRing(QQ).objgen()\n            sage: f = R.hom([5], GF(7))\n            Traceback (most recent call last):\n            ...\n            TypeError: images (=[5]) do not define a valid homomorphism\n\n            sage: R, x = PolynomialRing(GF(7)).objgen()\n            sage: f = R.hom([3], GF(49))\n            sage: f\n            Ring morphism:\n              From: Univariate Polynomial Ring in x over Finite Field of size 7\n              To:   Finite Field in a of size 7^2\n              Defn: x |--> 3\n            sage: f(x+6)\n            2\n            sage: f(x^2+1)\n            3\n\n        EXAMPLE: Natural morphism\n            sage: f = ZZ.hom(GF(5))\n            sage: f(7)\n            2\n            sage: f\n            Coercion morphism:\n              From: Integer Ring\n              To:   Finite Field of size 5\n\n        There might not be a natural morphism, in which case a TypeError exception is raised. \n            sage: QQ.hom(ZZ)\n            Traceback (most recent call last):\n            ...\n            TypeError: Natural coercion morphism from Rational Field to Integer Ring not defined.\n        ";
static PyObject *__pyx_f_4gens_10Generators_hom(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_im_gens = 0;
  PyObject *__pyx_v_codomain = 0;
  PyObject *__pyx_v_check = 0;
  PyObject *__pyx_v_Sequence;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  int __pyx_5;
  int __pyx_6;
  static char *__pyx_argnames[] = {"im_gens","codomain","check",0};
  __pyx_v_codomain = __pyx_k7;
  __pyx_v_check = __pyx_k8;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|OO", __pyx_argnames, &__pyx_v_im_gens, &__pyx_v_codomain, &__pyx_v_check)) return 0;
  Py_INCREF((PyObject *)__pyx_v_self);
  Py_INCREF(__pyx_v_im_gens);
  Py_INCREF(__pyx_v_codomain);
  Py_INCREF(__pyx_v_check);
  __pyx_v_Sequence = Py_None; Py_INCREF(Py_None);

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":341 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_isinstance); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 341; goto __pyx_L1;}
  __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_tuple); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 341; goto __pyx_L1;}
  __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_list); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 341; goto __pyx_L1;}
  __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 341; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_4, 0, __pyx_2);
  PyTuple_SET_ITEM(__pyx_4, 1, __pyx_3);
  __pyx_2 = 0;
  __pyx_3 = 0;
  __pyx_2 = PyTuple_New(2); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 341; goto __pyx_L1;}
  Py_INCREF(__pyx_v_im_gens);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_im_gens);
  PyTuple_SET_ITEM(__pyx_2, 1, __pyx_4);
  __pyx_4 = 0;
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 341; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_5 = PyObject_IsTrue(__pyx_3); if (__pyx_5 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 341; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_6 = (!__pyx_5);
  if (__pyx_6) {

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":342 */
    __pyx_4 = PyObject_GetAttr(__pyx_v_self, __pyx_n_Hom); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 342; goto __pyx_L1;}
    __pyx_1 = PyTuple_New(1); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 342; goto __pyx_L1;}
    Py_INCREF(__pyx_v_im_gens);
    PyTuple_SET_ITEM(__pyx_1, 0, __pyx_v_im_gens);
    __pyx_2 = PyObject_CallObject(__pyx_4, __pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 342; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    __pyx_3 = PyObject_GetAttr(__pyx_2, __pyx_n_natural_map); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 342; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_4 = PyTuple_New(0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 342; goto __pyx_L1;}
    __pyx_1 = PyObject_CallObject(__pyx_3, __pyx_4); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 342; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":343 */
  __pyx_5 = __pyx_v_codomain == Py_None;
  if (__pyx_5) {

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":344 */
    __pyx_2 = PyList_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 344; goto __pyx_L1;}
    Py_INCREF(__pyx_n_Sequence);
    PyList_SET_ITEM(__pyx_2, 0, __pyx_n_Sequence);
    __pyx_3 = __Pyx_Import(__pyx_k20p, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 344; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_4 = PyObject_GetAttr(__pyx_3, __pyx_n_Sequence); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 344; goto __pyx_L1;}
    Py_DECREF(__pyx_v_Sequence);
    __pyx_v_Sequence = __pyx_4;
    __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":345 */
    __pyx_1 = PyTuple_New(1); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 345; goto __pyx_L1;}
    Py_INCREF(__pyx_v_im_gens);
    PyTuple_SET_ITEM(__pyx_1, 0, __pyx_v_im_gens);
    __pyx_2 = PyObject_CallObject(__pyx_v_Sequence, __pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 345; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_v_im_gens);
    __pyx_v_im_gens = __pyx_2;
    __pyx_2 = 0;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":346 */
    __pyx_3 = PyObject_GetAttr(__pyx_v_im_gens, __pyx_n_universe); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 346; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 346; goto __pyx_L1;}
    __pyx_1 = PyObject_CallObject(__pyx_3, __pyx_4); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 346; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_v_codomain);
    __pyx_v_codomain = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L3;
  }
  __pyx_L3:;

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":347 */
  __pyx_2 = PyObject_GetAttr(__pyx_v_self, __pyx_n_Hom); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 347; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 347; goto __pyx_L1;}
  Py_INCREF(__pyx_v_codomain);
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_codomain);
  __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 347; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_1 = PyTuple_New(1); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 347; goto __pyx_L1;}
  Py_INCREF(__pyx_v_im_gens);
  PyTuple_SET_ITEM(__pyx_1, 0, __pyx_v_im_gens);
  __pyx_2 = PyDict_New(); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 347; goto __pyx_L1;}
  if (PyDict_SetItem(__pyx_2, __pyx_n_check, __pyx_v_check) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 347; goto __pyx_L1;}
  __pyx_3 = PyEval_CallObjectWithKeywords(__pyx_4, __pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 347; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("gens.Generators.hom");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_Sequence);
  Py_DECREF((PyObject *)__pyx_v_self);
  Py_DECREF(__pyx_v_im_gens);
  Py_DECREF(__pyx_v_codomain);
  Py_DECREF(__pyx_v_check);
  return __pyx_r;
}

static PyObject *__pyx_n___generator_orders;
static PyObject *__pyx_n_multiplicative_order;

static PyObject *__pyx_f_4gens_31MultiplicativeAbelianGenerators_generator_orders(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_4gens_31MultiplicativeAbelianGenerators_generator_orders(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_g;
  PyObject *__pyx_v_x;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  PyObject *__pyx_6 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF((PyObject *)__pyx_v_self);
  __pyx_v_g = Py_None; Py_INCREF(Py_None);
  __pyx_v_x = Py_None; Py_INCREF(Py_None);

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":352 */
  /*try:*/ {

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":353 */
    __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n___generator_orders); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 353; goto __pyx_L2;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;
  }
  goto __pyx_L3;
  __pyx_L2:;
  Py_XDECREF(__pyx_1); __pyx_1 = 0;

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":354 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_AttributeError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 354; goto __pyx_L1;}
  __pyx_2 = PyErr_ExceptionMatches(__pyx_1);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  if (__pyx_2) {
    __Pyx_AddTraceback("gens.generator_orders");
    __pyx_1 = __Pyx_GetExcValue(); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 354; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":355 */
    __pyx_1 = PyList_New(0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 355; goto __pyx_L1;}
    Py_DECREF(__pyx_v_g);
    __pyx_v_g = __pyx_1;
    __pyx_1 = 0;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":356 */
    __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n_gens); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 356; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 356; goto __pyx_L1;}
    __pyx_4 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 356; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_1 = PyObject_GetIter(__pyx_4); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 356; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    for (;;) {
      __pyx_L4:;
      __pyx_3 = PyIter_Next(__pyx_1);
      if (!__pyx_3) {
        if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 356; goto __pyx_L1;}
        break;
      }
      Py_DECREF(__pyx_v_x);
      __pyx_v_x = __pyx_3;
      __pyx_3 = 0;

      /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":357 */
      __pyx_4 = PyObject_GetAttr(__pyx_v_g, __pyx_n_append); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 357; goto __pyx_L1;}
      __pyx_3 = PyObject_GetAttr(__pyx_v_x, __pyx_n_multiplicative_order); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 357; goto __pyx_L1;}
      __pyx_5 = PyTuple_New(0); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 357; goto __pyx_L1;}
      __pyx_6 = PyObject_CallObject(__pyx_3, __pyx_5); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 357; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 357; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_6);
      __pyx_6 = 0;
      __pyx_5 = PyObject_CallObject(__pyx_4, __pyx_3); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 357; goto __pyx_L1;}
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_5); __pyx_5 = 0;
    }
    __pyx_L5:;
    Py_DECREF(__pyx_1); __pyx_1 = 0;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":358 */
    if (PyObject_SetAttr(__pyx_v_self, __pyx_n___generator_orders, __pyx_v_g) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 358; goto __pyx_L1;}

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":359 */
    Py_INCREF(__pyx_v_g);
    __pyx_r = __pyx_v_g;
    goto __pyx_L0;
    goto __pyx_L3;
  }
  goto __pyx_L1;
  __pyx_L3:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  Py_XDECREF(__pyx_6);
  __Pyx_AddTraceback("gens.MultiplicativeAbelianGenerators.generator_orders");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_g);
  Py_DECREF(__pyx_v_x);
  Py_DECREF((PyObject *)__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_n_multiplicative_iterator;

static PyObject *__pyx_f_4gens_31MultiplicativeAbelianGenerators___iter__(PyObject *__pyx_v_self); /*proto*/
static char __pyx_doc_4gens_31MultiplicativeAbelianGenerators___iter__[] = "\n        Return an iterator over the elements in this object.\n        ";
static PyObject *__pyx_f_4gens_31MultiplicativeAbelianGenerators___iter__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  Py_INCREF((PyObject *)__pyx_v_self);

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":365 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_gens_py); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 365; goto __pyx_L1;}
  __pyx_2 = PyObject_GetAttr(__pyx_1, __pyx_n_multiplicative_iterator); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 365; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  __pyx_1 = PyTuple_New(1); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 365; goto __pyx_L1;}
  Py_INCREF(__pyx_v_self);
  PyTuple_SET_ITEM(__pyx_1, 0, __pyx_v_self);
  __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 365; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("gens.MultiplicativeAbelianGenerators.__iter__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF((PyObject *)__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_n_additive_order;

static PyObject *__pyx_f_4gens_25AdditiveAbelianGenerators_generator_orders(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_4gens_25AdditiveAbelianGenerators_generator_orders(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_g;
  PyObject *__pyx_v_x;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  PyObject *__pyx_6 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF((PyObject *)__pyx_v_self);
  __pyx_v_g = Py_None; Py_INCREF(Py_None);
  __pyx_v_x = Py_None; Py_INCREF(Py_None);

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":371 */
  /*try:*/ {

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":372 */
    __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n___generator_orders); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 372; goto __pyx_L2;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;
  }
  goto __pyx_L3;
  __pyx_L2:;
  Py_XDECREF(__pyx_1); __pyx_1 = 0;

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":373 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_AttributeError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 373; goto __pyx_L1;}
  __pyx_2 = PyErr_ExceptionMatches(__pyx_1);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  if (__pyx_2) {
    __Pyx_AddTraceback("gens.generator_orders");
    __pyx_1 = __Pyx_GetExcValue(); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 373; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":374 */
    __pyx_1 = PyList_New(0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 374; goto __pyx_L1;}
    Py_DECREF(__pyx_v_g);
    __pyx_v_g = __pyx_1;
    __pyx_1 = 0;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":375 */
    __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n_gens); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 375; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 375; goto __pyx_L1;}
    __pyx_4 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 375; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_1 = PyObject_GetIter(__pyx_4); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 375; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    for (;;) {
      __pyx_L4:;
      __pyx_3 = PyIter_Next(__pyx_1);
      if (!__pyx_3) {
        if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 375; goto __pyx_L1;}
        break;
      }
      Py_DECREF(__pyx_v_x);
      __pyx_v_x = __pyx_3;
      __pyx_3 = 0;

      /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":376 */
      __pyx_4 = PyObject_GetAttr(__pyx_v_g, __pyx_n_append); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 376; goto __pyx_L1;}
      __pyx_3 = PyObject_GetAttr(__pyx_v_x, __pyx_n_additive_order); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 376; goto __pyx_L1;}
      __pyx_5 = PyTuple_New(0); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 376; goto __pyx_L1;}
      __pyx_6 = PyObject_CallObject(__pyx_3, __pyx_5); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 376; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 376; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_6);
      __pyx_6 = 0;
      __pyx_5 = PyObject_CallObject(__pyx_4, __pyx_3); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 376; goto __pyx_L1;}
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_5); __pyx_5 = 0;
    }
    __pyx_L5:;
    Py_DECREF(__pyx_1); __pyx_1 = 0;

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":377 */
    if (PyObject_SetAttr(__pyx_v_self, __pyx_n___generator_orders, __pyx_v_g) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 377; goto __pyx_L1;}

    /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":378 */
    Py_INCREF(__pyx_v_g);
    __pyx_r = __pyx_v_g;
    goto __pyx_L0;
    goto __pyx_L3;
  }
  goto __pyx_L1;
  __pyx_L3:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  Py_XDECREF(__pyx_6);
  __Pyx_AddTraceback("gens.AdditiveAbelianGenerators.generator_orders");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_g);
  Py_DECREF(__pyx_v_x);
  Py_DECREF((PyObject *)__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_n_abelian_iterator;

static PyObject *__pyx_f_4gens_25AdditiveAbelianGenerators___iter__(PyObject *__pyx_v_self); /*proto*/
static char __pyx_doc_4gens_25AdditiveAbelianGenerators___iter__[] = "\n        Return an iterator over the elements in this object.\n        ";
static PyObject *__pyx_f_4gens_25AdditiveAbelianGenerators___iter__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  Py_INCREF((PyObject *)__pyx_v_self);

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":384 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_gens_py); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 384; goto __pyx_L1;}
  __pyx_2 = PyObject_GetAttr(__pyx_1, __pyx_n_abelian_iterator); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 384; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  __pyx_1 = PyTuple_New(1); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 384; goto __pyx_L1;}
  Py_INCREF(__pyx_v_self);
  PyTuple_SET_ITEM(__pyx_1, 0, __pyx_v_self);
  __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 384; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("gens.AdditiveAbelianGenerators.__iter__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF((PyObject *)__pyx_v_self);
  return __pyx_r;
}

static __Pyx_InternTabEntry __pyx_intern_tab[] = {
  {&__pyx_n_AttributeError, "AttributeError"},
  {&__pyx_n_Hom, "Hom"},
  {&__pyx_n_IndexError, "IndexError"},
  {&__pyx_n_NotImplementedError, "NotImplementedError"},
  {&__pyx_n_Sequence, "Sequence"},
  {&__pyx_n_True, "True"},
  {&__pyx_n_TypeError, "TypeError"},
  {&__pyx_n_ValueError, "ValueError"},
  {&__pyx_n___certify_names, "__certify_names"},
  {&__pyx_n___generator_orders, "__generator_orders"},
  {&__pyx_n___gens, "__gens"},
  {&__pyx_n___gens_dict, "__gens_dict"},
  {&__pyx_n___iter__, "__iter__"},
  {&__pyx_n___latex_names, "__latex_names"},
  {&__pyx_n___list, "__list"},
  {&__pyx_n___names, "__names"},
  {&__pyx_n_abelian_iterator, "abelian_iterator"},
  {&__pyx_n_additive_order, "additive_order"},
  {&__pyx_n_append, "append"},
  {&__pyx_n_assign_names, "assign_names"},
  {&__pyx_n_check, "check"},
  {&__pyx_n_defaults, "defaults"},
  {&__pyx_n_find, "find"},
  {&__pyx_n_gen, "gen"},
  {&__pyx_n_gens, "gens"},
  {&__pyx_n_gens_py, "gens_py"},
  {&__pyx_n_int, "int"},
  {&__pyx_n_isalnum, "isalnum"},
  {&__pyx_n_isinstance, "isinstance"},
  {&__pyx_n_latex_variable_names, "latex_variable_names"},
  {&__pyx_n_len, "len"},
  {&__pyx_n_list, "list"},
  {&__pyx_n_misc, "misc"},
  {&__pyx_n_multiplicative_iterator, "multiplicative_iterator"},
  {&__pyx_n_multiplicative_order, "multiplicative_order"},
  {&__pyx_n_natural_map, "natural_map"},
  {&__pyx_n_ngens, "ngens"},
  {&__pyx_n_sage, "sage"},
  {&__pyx_n_sage_object, "sage_object"},
  {&__pyx_n_split, "split"},
  {&__pyx_n_str, "str"},
  {&__pyx_n_strip, "strip"},
  {&__pyx_n_tuple, "tuple"},
  {&__pyx_n_universe, "universe"},
  {&__pyx_n_variable_name, "variable_name"},
  {&__pyx_n_variable_names, "variable_names"},
  {0, 0}
};

static __Pyx_StringTabEntry __pyx_string_tab[] = {
  {&__pyx_k1p, __pyx_k1, sizeof(__pyx_k1)},
  {&__pyx_k9p, __pyx_k9, sizeof(__pyx_k9)},
  {&__pyx_k10p, __pyx_k10, sizeof(__pyx_k10)},
  {&__pyx_k11p, __pyx_k11, sizeof(__pyx_k11)},
  {&__pyx_k12p, __pyx_k12, sizeof(__pyx_k12)},
  {&__pyx_k13p, __pyx_k13, sizeof(__pyx_k13)},
  {&__pyx_k14p, __pyx_k14, sizeof(__pyx_k14)},
  {&__pyx_k15p, __pyx_k15, sizeof(__pyx_k15)},
  {&__pyx_k16p, __pyx_k16, sizeof(__pyx_k16)},
  {&__pyx_k17p, __pyx_k17, sizeof(__pyx_k17)},
  {&__pyx_k18p, __pyx_k18, sizeof(__pyx_k18)},
  {&__pyx_k19p, __pyx_k19, sizeof(__pyx_k19)},
  {&__pyx_k20p, __pyx_k20, sizeof(__pyx_k20)},
  {0, 0, 0}
};

static PyObject *__pyx_tp_new_4gens_Generators(PyTypeObject *t, PyObject *a, PyObject *k) {
  PyObject *o = __pyx_ptype_11sage_object_SageObject->tp_new(t, a, k);
  struct __pyx_obj_4gens_Generators *p = (struct __pyx_obj_4gens_Generators *)o;
  return o;
}

static void __pyx_tp_dealloc_4gens_Generators(PyObject *o) {
  struct __pyx_obj_4gens_Generators *p = (struct __pyx_obj_4gens_Generators *)o;
  __pyx_ptype_11sage_object_SageObject->tp_dealloc(o);
}

static int __pyx_tp_traverse_4gens_Generators(PyObject *o, visitproc v, void *a) {
  int e;
  struct __pyx_obj_4gens_Generators *p = (struct __pyx_obj_4gens_Generators *)o;
  e = __pyx_ptype_11sage_object_SageObject->tp_traverse(o, v, a); if (e) return e;
  return 0;
}

static int __pyx_tp_clear_4gens_Generators(PyObject *o) {
  struct __pyx_obj_4gens_Generators *p = (struct __pyx_obj_4gens_Generators *)o;
  __pyx_ptype_11sage_object_SageObject->tp_clear(o);
  return 0;
}
static PyObject *__pyx_sq_item_4gens_Generators(PyObject *o, int i) {
  PyObject *r;
  PyObject *x = PyInt_FromLong(i); if(!x) return 0;
  r = o->ob_type->tp_as_mapping->mp_subscript(o, x);
  Py_DECREF(x);
  return r;
}

static struct PyMethodDef __pyx_methods_4gens_Generators[] = {
  {"ngens", (PyCFunction)__pyx_f_4gens_10Generators_ngens, METH_VARARGS|METH_KEYWORDS, 0},
  {"gen", (PyCFunction)__pyx_f_4gens_10Generators_gen, METH_VARARGS|METH_KEYWORDS, 0},
  {"list", (PyCFunction)__pyx_f_4gens_10Generators_list, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4gens_10Generators_list},
  {"objgens", (PyCFunction)__pyx_f_4gens_10Generators_objgens, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4gens_10Generators_objgens},
  {"objgen", (PyCFunction)__pyx_f_4gens_10Generators_objgen, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4gens_10Generators_objgen},
  {"gens", (PyCFunction)__pyx_f_4gens_10Generators_gens, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4gens_10Generators_gens},
  {"gens_dict", (PyCFunction)__pyx_f_4gens_10Generators_gens_dict, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4gens_10Generators_gens_dict},
  {"__certify_names", (PyCFunction)__pyx_f_4gens_10Generators___certify_names, METH_VARARGS|METH_KEYWORDS, 0},
  {"assign_names", (PyCFunction)__pyx_f_4gens_10Generators_assign_names, METH_VARARGS|METH_KEYWORDS, 0},
  {"_names_from_obj", (PyCFunction)__pyx_f_4gens_10Generators__names_from_obj, METH_VARARGS|METH_KEYWORDS, 0},
  {"variable_names", (PyCFunction)__pyx_f_4gens_10Generators_variable_names, METH_VARARGS|METH_KEYWORDS, 0},
  {"latex_variable_names", (PyCFunction)__pyx_f_4gens_10Generators_latex_variable_names, METH_VARARGS|METH_KEYWORDS, 0},
  {"variable_name", (PyCFunction)__pyx_f_4gens_10Generators_variable_name, METH_VARARGS|METH_KEYWORDS, 0},
  {"latex_name", (PyCFunction)__pyx_f_4gens_10Generators_latex_name, METH_VARARGS|METH_KEYWORDS, 0},
  {"_is_valid_homomorphism_", (PyCFunction)__pyx_f_4gens_10Generators__is_valid_homomorphism_, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4gens_10Generators__is_valid_homomorphism_},
  {"hom", (PyCFunction)__pyx_f_4gens_10Generators_hom, METH_VARARGS|METH_KEYWORDS, __pyx_doc_4gens_10Generators_hom},
  {0, 0, 0, 0}
};

static PyNumberMethods __pyx_tp_as_number_Generators = {
  0, /*nb_add*/
  0, /*nb_subtract*/
  0, /*nb_multiply*/
  0, /*nb_divide*/
  0, /*nb_remainder*/
  0, /*nb_divmod*/
  0, /*nb_power*/
  0, /*nb_negative*/
  0, /*nb_positive*/
  0, /*nb_absolute*/
  0, /*nb_nonzero*/
  0, /*nb_invert*/
  0, /*nb_lshift*/
  0, /*nb_rshift*/
  0, /*nb_and*/
  0, /*nb_xor*/
  0, /*nb_or*/
  0, /*nb_coerce*/
  0, /*nb_int*/
  0, /*nb_long*/
  0, /*nb_float*/
  0, /*nb_oct*/
  0, /*nb_hex*/
  0, /*nb_inplace_add*/
  0, /*nb_inplace_subtract*/
  0, /*nb_inplace_multiply*/
  0, /*nb_inplace_divide*/
  0, /*nb_inplace_remainder*/
  0, /*nb_inplace_power*/
  0, /*nb_inplace_lshift*/
  0, /*nb_inplace_rshift*/
  0, /*nb_inplace_and*/
  0, /*nb_inplace_xor*/
  0, /*nb_inplace_or*/
  0, /*nb_floor_divide*/
  0, /*nb_true_divide*/
  0, /*nb_inplace_floor_divide*/
  0, /*nb_inplace_true_divide*/
};

static PySequenceMethods __pyx_tp_as_sequence_Generators = {
  __pyx_f_4gens_10Generators___len__, /*sq_length*/
  0, /*sq_concat*/
  0, /*sq_repeat*/
  __pyx_sq_item_4gens_Generators, /*sq_item*/
  __pyx_f_4gens_10Generators___getslice__, /*sq_slice*/
  0, /*sq_ass_item*/
  0, /*sq_ass_slice*/
  0, /*sq_contains*/
  0, /*sq_inplace_concat*/
  0, /*sq_inplace_repeat*/
};

static PyMappingMethods __pyx_tp_as_mapping_Generators = {
  __pyx_f_4gens_10Generators___len__, /*mp_length*/
  __pyx_f_4gens_10Generators___getitem__, /*mp_subscript*/
  0, /*mp_ass_subscript*/
};

static PyBufferProcs __pyx_tp_as_buffer_Generators = {
  0, /*bf_getreadbuffer*/
  0, /*bf_getwritebuffer*/
  0, /*bf_getsegcount*/
  0, /*bf_getcharbuffer*/
};

PyTypeObject __pyx_type_4gens_Generators = {
  PyObject_HEAD_INIT(0)
  0, /*ob_size*/
  "gens.Generators", /*tp_name*/
  sizeof(struct __pyx_obj_4gens_Generators), /*tp_basicsize*/
  0, /*tp_itemsize*/
  __pyx_tp_dealloc_4gens_Generators, /*tp_dealloc*/
  0, /*tp_print*/
  0, /*tp_getattr*/
  0, /*tp_setattr*/
  0, /*tp_compare*/
  0, /*tp_repr*/
  &__pyx_tp_as_number_Generators, /*tp_as_number*/
  &__pyx_tp_as_sequence_Generators, /*tp_as_sequence*/
  &__pyx_tp_as_mapping_Generators, /*tp_as_mapping*/
  0, /*tp_hash*/
  0, /*tp_call*/
  0, /*tp_str*/
  0, /*tp_getattro*/
  0, /*tp_setattro*/
  &__pyx_tp_as_buffer_Generators, /*tp_as_buffer*/
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_CHECKTYPES|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC, /*tp_flags*/
  0, /*tp_doc*/
  __pyx_tp_traverse_4gens_Generators, /*tp_traverse*/
  __pyx_tp_clear_4gens_Generators, /*tp_clear*/
  0, /*tp_richcompare*/
  0, /*tp_weaklistoffset*/
  0, /*tp_iter*/
  0, /*tp_iternext*/
  __pyx_methods_4gens_Generators, /*tp_methods*/
  0, /*tp_members*/
  0, /*tp_getset*/
  0, /*tp_base*/
  0, /*tp_dict*/
  0, /*tp_descr_get*/
  0, /*tp_descr_set*/
  0, /*tp_dictoffset*/
  0, /*tp_init*/
  0, /*tp_alloc*/
  __pyx_tp_new_4gens_Generators, /*tp_new*/
  0, /*tp_free*/
  0, /*tp_is_gc*/
  0, /*tp_bases*/
  0, /*tp_mro*/
  0, /*tp_cache*/
  0, /*tp_subclasses*/
  0, /*tp_weaklist*/
};

static PyObject *__pyx_tp_new_4gens_MultiplicativeAbelianGenerators(PyTypeObject *t, PyObject *a, PyObject *k) {
  PyObject *o = __pyx_ptype_4gens_Generators->tp_new(t, a, k);
  struct __pyx_obj_4gens_MultiplicativeAbelianGenerators *p = (struct __pyx_obj_4gens_MultiplicativeAbelianGenerators *)o;
  return o;
}

static void __pyx_tp_dealloc_4gens_MultiplicativeAbelianGenerators(PyObject *o) {
  struct __pyx_obj_4gens_MultiplicativeAbelianGenerators *p = (struct __pyx_obj_4gens_MultiplicativeAbelianGenerators *)o;
  __pyx_ptype_4gens_Generators->tp_dealloc(o);
}

static int __pyx_tp_traverse_4gens_MultiplicativeAbelianGenerators(PyObject *o, visitproc v, void *a) {
  int e;
  struct __pyx_obj_4gens_MultiplicativeAbelianGenerators *p = (struct __pyx_obj_4gens_MultiplicativeAbelianGenerators *)o;
  e = __pyx_ptype_4gens_Generators->tp_traverse(o, v, a); if (e) return e;
  return 0;
}

static int __pyx_tp_clear_4gens_MultiplicativeAbelianGenerators(PyObject *o) {
  struct __pyx_obj_4gens_MultiplicativeAbelianGenerators *p = (struct __pyx_obj_4gens_MultiplicativeAbelianGenerators *)o;
  __pyx_ptype_4gens_Generators->tp_clear(o);
  return 0;
}

static struct PyMethodDef __pyx_methods_4gens_MultiplicativeAbelianGenerators[] = {
  {"generator_orders", (PyCFunction)__pyx_f_4gens_31MultiplicativeAbelianGenerators_generator_orders, METH_VARARGS|METH_KEYWORDS, 0},
  {0, 0, 0, 0}
};

static PyNumberMethods __pyx_tp_as_number_MultiplicativeAbelianGenerators = {
  0, /*nb_add*/
  0, /*nb_subtract*/
  0, /*nb_multiply*/
  0, /*nb_divide*/
  0, /*nb_remainder*/
  0, /*nb_divmod*/
  0, /*nb_power*/
  0, /*nb_negative*/
  0, /*nb_positive*/
  0, /*nb_absolute*/
  0, /*nb_nonzero*/
  0, /*nb_invert*/
  0, /*nb_lshift*/
  0, /*nb_rshift*/
  0, /*nb_and*/
  0, /*nb_xor*/
  0, /*nb_or*/
  0, /*nb_coerce*/
  0, /*nb_int*/
  0, /*nb_long*/
  0, /*nb_float*/
  0, /*nb_oct*/
  0, /*nb_hex*/
  0, /*nb_inplace_add*/
  0, /*nb_inplace_subtract*/
  0, /*nb_inplace_multiply*/
  0, /*nb_inplace_divide*/
  0, /*nb_inplace_remainder*/
  0, /*nb_inplace_power*/
  0, /*nb_inplace_lshift*/
  0, /*nb_inplace_rshift*/
  0, /*nb_inplace_and*/
  0, /*nb_inplace_xor*/
  0, /*nb_inplace_or*/
  0, /*nb_floor_divide*/
  0, /*nb_true_divide*/
  0, /*nb_inplace_floor_divide*/
  0, /*nb_inplace_true_divide*/
};

static PySequenceMethods __pyx_tp_as_sequence_MultiplicativeAbelianGenerators = {
  0, /*sq_length*/
  0, /*sq_concat*/
  0, /*sq_repeat*/
  0, /*sq_item*/
  0, /*sq_slice*/
  0, /*sq_ass_item*/
  0, /*sq_ass_slice*/
  0, /*sq_contains*/
  0, /*sq_inplace_concat*/
  0, /*sq_inplace_repeat*/
};

static PyMappingMethods __pyx_tp_as_mapping_MultiplicativeAbelianGenerators = {
  0, /*mp_length*/
  0, /*mp_subscript*/
  0, /*mp_ass_subscript*/
};

static PyBufferProcs __pyx_tp_as_buffer_MultiplicativeAbelianGenerators = {
  0, /*bf_getreadbuffer*/
  0, /*bf_getwritebuffer*/
  0, /*bf_getsegcount*/
  0, /*bf_getcharbuffer*/
};

PyTypeObject __pyx_type_4gens_MultiplicativeAbelianGenerators = {
  PyObject_HEAD_INIT(0)
  0, /*ob_size*/
  "gens.MultiplicativeAbelianGenerators", /*tp_name*/
  sizeof(struct __pyx_obj_4gens_MultiplicativeAbelianGenerators), /*tp_basicsize*/
  0, /*tp_itemsize*/
  __pyx_tp_dealloc_4gens_MultiplicativeAbelianGenerators, /*tp_dealloc*/
  0, /*tp_print*/
  0, /*tp_getattr*/
  0, /*tp_setattr*/
  0, /*tp_compare*/
  0, /*tp_repr*/
  &__pyx_tp_as_number_MultiplicativeAbelianGenerators, /*tp_as_number*/
  &__pyx_tp_as_sequence_MultiplicativeAbelianGenerators, /*tp_as_sequence*/
  &__pyx_tp_as_mapping_MultiplicativeAbelianGenerators, /*tp_as_mapping*/
  0, /*tp_hash*/
  0, /*tp_call*/
  0, /*tp_str*/
  0, /*tp_getattro*/
  0, /*tp_setattro*/
  &__pyx_tp_as_buffer_MultiplicativeAbelianGenerators, /*tp_as_buffer*/
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_CHECKTYPES|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC, /*tp_flags*/
  0, /*tp_doc*/
  __pyx_tp_traverse_4gens_MultiplicativeAbelianGenerators, /*tp_traverse*/
  __pyx_tp_clear_4gens_MultiplicativeAbelianGenerators, /*tp_clear*/
  0, /*tp_richcompare*/
  0, /*tp_weaklistoffset*/
  __pyx_f_4gens_31MultiplicativeAbelianGenerators___iter__, /*tp_iter*/
  0, /*tp_iternext*/
  __pyx_methods_4gens_MultiplicativeAbelianGenerators, /*tp_methods*/
  0, /*tp_members*/
  0, /*tp_getset*/
  0, /*tp_base*/
  0, /*tp_dict*/
  0, /*tp_descr_get*/
  0, /*tp_descr_set*/
  0, /*tp_dictoffset*/
  0, /*tp_init*/
  0, /*tp_alloc*/
  __pyx_tp_new_4gens_MultiplicativeAbelianGenerators, /*tp_new*/
  0, /*tp_free*/
  0, /*tp_is_gc*/
  0, /*tp_bases*/
  0, /*tp_mro*/
  0, /*tp_cache*/
  0, /*tp_subclasses*/
  0, /*tp_weaklist*/
};

static PyObject *__pyx_tp_new_4gens_AdditiveAbelianGenerators(PyTypeObject *t, PyObject *a, PyObject *k) {
  PyObject *o = __pyx_ptype_4gens_Generators->tp_new(t, a, k);
  struct __pyx_obj_4gens_AdditiveAbelianGenerators *p = (struct __pyx_obj_4gens_AdditiveAbelianGenerators *)o;
  return o;
}

static void __pyx_tp_dealloc_4gens_AdditiveAbelianGenerators(PyObject *o) {
  struct __pyx_obj_4gens_AdditiveAbelianGenerators *p = (struct __pyx_obj_4gens_AdditiveAbelianGenerators *)o;
  __pyx_ptype_4gens_Generators->tp_dealloc(o);
}

static int __pyx_tp_traverse_4gens_AdditiveAbelianGenerators(PyObject *o, visitproc v, void *a) {
  int e;
  struct __pyx_obj_4gens_AdditiveAbelianGenerators *p = (struct __pyx_obj_4gens_AdditiveAbelianGenerators *)o;
  e = __pyx_ptype_4gens_Generators->tp_traverse(o, v, a); if (e) return e;
  return 0;
}

static int __pyx_tp_clear_4gens_AdditiveAbelianGenerators(PyObject *o) {
  struct __pyx_obj_4gens_AdditiveAbelianGenerators *p = (struct __pyx_obj_4gens_AdditiveAbelianGenerators *)o;
  __pyx_ptype_4gens_Generators->tp_clear(o);
  return 0;
}

static struct PyMethodDef __pyx_methods_4gens_AdditiveAbelianGenerators[] = {
  {"generator_orders", (PyCFunction)__pyx_f_4gens_25AdditiveAbelianGenerators_generator_orders, METH_VARARGS|METH_KEYWORDS, 0},
  {0, 0, 0, 0}
};

static PyNumberMethods __pyx_tp_as_number_AdditiveAbelianGenerators = {
  0, /*nb_add*/
  0, /*nb_subtract*/
  0, /*nb_multiply*/
  0, /*nb_divide*/
  0, /*nb_remainder*/
  0, /*nb_divmod*/
  0, /*nb_power*/
  0, /*nb_negative*/
  0, /*nb_positive*/
  0, /*nb_absolute*/
  0, /*nb_nonzero*/
  0, /*nb_invert*/
  0, /*nb_lshift*/
  0, /*nb_rshift*/
  0, /*nb_and*/
  0, /*nb_xor*/
  0, /*nb_or*/
  0, /*nb_coerce*/
  0, /*nb_int*/
  0, /*nb_long*/
  0, /*nb_float*/
  0, /*nb_oct*/
  0, /*nb_hex*/
  0, /*nb_inplace_add*/
  0, /*nb_inplace_subtract*/
  0, /*nb_inplace_multiply*/
  0, /*nb_inplace_divide*/
  0, /*nb_inplace_remainder*/
  0, /*nb_inplace_power*/
  0, /*nb_inplace_lshift*/
  0, /*nb_inplace_rshift*/
  0, /*nb_inplace_and*/
  0, /*nb_inplace_xor*/
  0, /*nb_inplace_or*/
  0, /*nb_floor_divide*/
  0, /*nb_true_divide*/
  0, /*nb_inplace_floor_divide*/
  0, /*nb_inplace_true_divide*/
};

static PySequenceMethods __pyx_tp_as_sequence_AdditiveAbelianGenerators = {
  0, /*sq_length*/
  0, /*sq_concat*/
  0, /*sq_repeat*/
  0, /*sq_item*/
  0, /*sq_slice*/
  0, /*sq_ass_item*/
  0, /*sq_ass_slice*/
  0, /*sq_contains*/
  0, /*sq_inplace_concat*/
  0, /*sq_inplace_repeat*/
};

static PyMappingMethods __pyx_tp_as_mapping_AdditiveAbelianGenerators = {
  0, /*mp_length*/
  0, /*mp_subscript*/
  0, /*mp_ass_subscript*/
};

static PyBufferProcs __pyx_tp_as_buffer_AdditiveAbelianGenerators = {
  0, /*bf_getreadbuffer*/
  0, /*bf_getwritebuffer*/
  0, /*bf_getsegcount*/
  0, /*bf_getcharbuffer*/
};

PyTypeObject __pyx_type_4gens_AdditiveAbelianGenerators = {
  PyObject_HEAD_INIT(0)
  0, /*ob_size*/
  "gens.AdditiveAbelianGenerators", /*tp_name*/
  sizeof(struct __pyx_obj_4gens_AdditiveAbelianGenerators), /*tp_basicsize*/
  0, /*tp_itemsize*/
  __pyx_tp_dealloc_4gens_AdditiveAbelianGenerators, /*tp_dealloc*/
  0, /*tp_print*/
  0, /*tp_getattr*/
  0, /*tp_setattr*/
  0, /*tp_compare*/
  0, /*tp_repr*/
  &__pyx_tp_as_number_AdditiveAbelianGenerators, /*tp_as_number*/
  &__pyx_tp_as_sequence_AdditiveAbelianGenerators, /*tp_as_sequence*/
  &__pyx_tp_as_mapping_AdditiveAbelianGenerators, /*tp_as_mapping*/
  0, /*tp_hash*/
  0, /*tp_call*/
  0, /*tp_str*/
  0, /*tp_getattro*/
  0, /*tp_setattro*/
  &__pyx_tp_as_buffer_AdditiveAbelianGenerators, /*tp_as_buffer*/
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_CHECKTYPES|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC, /*tp_flags*/
  0, /*tp_doc*/
  __pyx_tp_traverse_4gens_AdditiveAbelianGenerators, /*tp_traverse*/
  __pyx_tp_clear_4gens_AdditiveAbelianGenerators, /*tp_clear*/
  0, /*tp_richcompare*/
  0, /*tp_weaklistoffset*/
  __pyx_f_4gens_25AdditiveAbelianGenerators___iter__, /*tp_iter*/
  0, /*tp_iternext*/
  __pyx_methods_4gens_AdditiveAbelianGenerators, /*tp_methods*/
  0, /*tp_members*/
  0, /*tp_getset*/
  0, /*tp_base*/
  0, /*tp_dict*/
  0, /*tp_descr_get*/
  0, /*tp_descr_set*/
  0, /*tp_dictoffset*/
  0, /*tp_init*/
  0, /*tp_alloc*/
  __pyx_tp_new_4gens_AdditiveAbelianGenerators, /*tp_new*/
  0, /*tp_free*/
  0, /*tp_is_gc*/
  0, /*tp_bases*/
  0, /*tp_mro*/
  0, /*tp_cache*/
  0, /*tp_subclasses*/
  0, /*tp_weaklist*/
};

static struct PyMethodDef __pyx_methods[] = {
  {0, 0, 0, 0}
};

static void __pyx_init_filenames(void); /*proto*/

PyMODINIT_FUNC initgens(void); /*proto*/
PyMODINIT_FUNC initgens(void) {
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  __pyx_init_filenames();
  __pyx_m = Py_InitModule4("gens", __pyx_methods, __pyx_mdoc, 0, PYTHON_API_VERSION);
  if (!__pyx_m) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1; goto __pyx_L1;};
  __pyx_b = PyImport_AddModule("__builtin__");
  if (!__pyx_b) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1; goto __pyx_L1;};
  if (PyObject_SetAttrString(__pyx_m, "__builtins__", __pyx_b) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1; goto __pyx_L1;};
  if (__Pyx_InternStrings(__pyx_intern_tab) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1; goto __pyx_L1;};
  if (__Pyx_InitStrings(__pyx_string_tab) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1; goto __pyx_L1;};
  __pyx_ptype_11sage_object_SageObject = __Pyx_ImportType("sage_object", "SageObject", sizeof(struct __pyx_obj_11sage_object_SageObject)); if (!__pyx_ptype_11sage_object_SageObject) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 1; goto __pyx_L1;}
  __pyx_type_4gens_Generators.tp_base = __pyx_ptype_11sage_object_SageObject;
  if (PyType_Ready(&__pyx_type_4gens_Generators) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 79; goto __pyx_L1;}
  if (PyObject_SetAttrString(__pyx_m, "Generators", (PyObject *)&__pyx_type_4gens_Generators) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 79; goto __pyx_L1;}
  __pyx_ptype_4gens_Generators = &__pyx_type_4gens_Generators;
  __pyx_type_4gens_MultiplicativeAbelianGenerators.tp_base = __pyx_ptype_4gens_Generators;
  if (PyType_Ready(&__pyx_type_4gens_MultiplicativeAbelianGenerators) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 350; goto __pyx_L1;}
  if (PyObject_SetAttrString(__pyx_m, "MultiplicativeAbelianGenerators", (PyObject *)&__pyx_type_4gens_MultiplicativeAbelianGenerators) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 350; goto __pyx_L1;}
  __pyx_ptype_4gens_MultiplicativeAbelianGenerators = &__pyx_type_4gens_MultiplicativeAbelianGenerators;
  __pyx_type_4gens_AdditiveAbelianGenerators.tp_base = __pyx_ptype_4gens_Generators;
  if (PyType_Ready(&__pyx_type_4gens_AdditiveAbelianGenerators) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 369; goto __pyx_L1;}
  if (PyObject_SetAttrString(__pyx_m, "AdditiveAbelianGenerators", (PyObject *)&__pyx_type_4gens_AdditiveAbelianGenerators) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 369; goto __pyx_L1;}
  __pyx_ptype_4gens_AdditiveAbelianGenerators = &__pyx_type_4gens_AdditiveAbelianGenerators;

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":71 */
  __pyx_1 = __Pyx_Import(__pyx_k1p, 0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 71; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_sage, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 71; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":72 */
  __pyx_1 = __Pyx_Import(__pyx_n_gens_py, 0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 72; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_gens_py, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 72; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":85 */
  __pyx_1 = PyInt_FromLong(0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 85; goto __pyx_L1;}
  __pyx_k3 = __pyx_1;
  __pyx_1 = 0;

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":108 */
  Py_INCREF(Py_None);
  __pyx_k4 = Py_None;

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":134 */
  Py_INCREF(Py_None);
  __pyx_k5 = Py_None;

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":202 */
  Py_INCREF(Py_None);
  __pyx_k6 = Py_None;

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":279 */
  Py_INCREF(Py_None);
  __pyx_k7 = Py_None;
  __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_True); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 279; goto __pyx_L1;}
  __pyx_k8 = __pyx_2;
  __pyx_2 = 0;

  /* "/home/was/sage-bdist/devel/sage-1.3.2.1/sage/ext/gens.pyx":380 */
  return;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("gens");
}

static char *__pyx_filenames[] = {
  "gens.pyx",
  "sage_object.pxd",
};

/* Runtime support code */

static void __pyx_init_filenames(void) {
  __pyx_f = __pyx_filenames;
}

static PyObject *__Pyx_Import(PyObject *name, PyObject *from_list) {
    PyObject *__import__ = 0;
    PyObject *empty_list = 0;
    PyObject *module = 0;
    PyObject *global_dict = 0;
    PyObject *empty_dict = 0;
    PyObject *list;
    __import__ = PyObject_GetAttrString(__pyx_b, "__import__");
    if (!__import__)
        goto bad;
    if (from_list)
        list = from_list;
    else {
        empty_list = PyList_New(0);
        if (!empty_list)
            goto bad;
        list = empty_list;
    }
    global_dict = PyModule_GetDict(__pyx_m);
    if (!global_dict)
        goto bad;
    empty_dict = PyDict_New();
    if (!empty_dict)
        goto bad;
    module = PyObject_CallFunction(__import__, "OOOO",
        name, global_dict, empty_dict, list);
bad:
    Py_XDECREF(empty_list);
    Py_XDECREF(__import__);
    Py_XDECREF(empty_dict);
    return module;
}

static PyObject *__Pyx_GetName(PyObject *dict, PyObject *name) {
    PyObject *result;
    result = PyObject_GetAttr(dict, name);
    if (!result)
        PyErr_SetObject(PyExc_NameError, name);
    return result;
}

static void __Pyx_Raise(PyObject *type, PyObject *value, PyObject *tb) {
    Py_XINCREF(type);
    Py_XINCREF(value);
    Py_XINCREF(tb);
    /* First, check the traceback argument, replacing None with NULL. */
    if (tb == Py_None) {
        Py_DECREF(tb);
        tb = 0;
    }
    else if (tb != NULL && !PyTraceBack_Check(tb)) {
        PyErr_SetString(PyExc_TypeError,
            "raise: arg 3 must be a traceback or None");
        goto raise_error;
    }
    /* Next, replace a missing value with None */
    if (value == NULL) {
        value = Py_None;
        Py_INCREF(value);
    }
    /* Next, repeatedly, replace a tuple exception with its first item */
    while (PyTuple_Check(type) && PyTuple_Size(type) > 0) {
        PyObject *tmp = type;
        type = PyTuple_GET_ITEM(type, 0);
        Py_INCREF(type);
        Py_DECREF(tmp);
    }
    if (PyString_Check(type))
        ;
    else if (PyClass_Check(type))
        ; /*PyErr_NormalizeException(&type, &value, &tb);*/
    else if (PyInstance_Check(type)) {
        /* Raising an instance.  The value should be a dummy. */
        if (value != Py_None) {
            PyErr_SetString(PyExc_TypeError,
              "instance exception may not have a separate value");
            goto raise_error;
        }
        else {
            /* Normalize to raise <class>, <instance> */
            Py_DECREF(value);
            value = type;
            type = (PyObject*) ((PyInstanceObject*)type)->in_class;
            Py_INCREF(type);
        }
    }
    else {
        /* Not something you can raise.  You get an exception
           anyway, just not what you specified :-) */
        PyErr_Format(PyExc_TypeError,
                 "exceptions must be strings, classes, or "
                 "instances, not %s", type->ob_type->tp_name);
        goto raise_error;
    }
    PyErr_Restore(type, value, tb);
    return;
raise_error:
    Py_XDECREF(value);
    Py_XDECREF(type);
    Py_XDECREF(tb);
    return;
}

static PyObject *__Pyx_GetExcValue(void) {
    PyObject *type = 0, *value = 0, *tb = 0;
    PyObject *result = 0;
    PyThreadState *tstate = PyThreadState_Get();
    PyErr_Fetch(&type, &value, &tb);
    PyErr_NormalizeException(&type, &value, &tb);
    if (PyErr_Occurred())
        goto bad;
    if (!value) {
        value = Py_None;
        Py_INCREF(value);
    }
    Py_XDECREF(tstate->exc_type);
    Py_XDECREF(tstate->exc_value);
    Py_XDECREF(tstate->exc_traceback);
    tstate->exc_type = type;
    tstate->exc_value = value;
    tstate->exc_traceback = tb;
    result = value;
    Py_XINCREF(result);
    type = 0;
    value = 0;
    tb = 0;
bad:
    Py_XDECREF(type);
    Py_XDECREF(value);
    Py_XDECREF(tb);
    return result;
}

static void __Pyx_UnpackError(void) {
    PyErr_SetString(PyExc_ValueError, "unpack sequence of wrong size");
}

static PyObject *__Pyx_UnpackItem(PyObject *seq, int i) {
  PyObject *item;
  if (!(item = PySequence_GetItem(seq, i))) {
    if (PyErr_ExceptionMatches(PyExc_IndexError))
    	__Pyx_UnpackError();
  }
  return item;
}

static int __Pyx_EndUnpack(PyObject *seq, int i) {
  PyObject *item;
  if (item = PySequence_GetItem(seq, i)) {
    Py_DECREF(item);
    __Pyx_UnpackError();
    return -1;
  }
  PyErr_Clear();
    return 0;
}

static int __Pyx_InternStrings(__Pyx_InternTabEntry *t) {
    while (t->p) {
        *t->p = PyString_InternFromString(t->s);
        if (!*t->p)
            return -1;
        ++t;
    }
    return 0;
}

static int __Pyx_InitStrings(__Pyx_StringTabEntry *t) {
    while (t->p) {
        *t->p = PyString_FromStringAndSize(t->s, t->n - 1);
        if (!*t->p)
            return -1;
        ++t;
    }
    return 0;
}

static PyTypeObject *__Pyx_ImportType(char *module_name, char *class_name, 
    long size) 
{
    PyObject *py_module_name = 0;
    PyObject *py_class_name = 0;
    PyObject *py_name_list = 0;
    PyObject *py_module = 0;
    PyObject *result = 0;
    
    py_module_name = PyString_FromString(module_name);
    if (!py_module_name)
        goto bad;
    py_class_name = PyString_FromString(class_name);
    if (!py_class_name)
        goto bad;
    py_name_list = PyList_New(1);
    if (!py_name_list)
        goto bad;
    Py_INCREF(py_class_name);
    if (PyList_SetItem(py_name_list, 0, py_class_name) < 0)
        goto bad;
    py_module = __Pyx_Import(py_module_name, py_name_list);
    if (!py_module)
        goto bad;
    result = PyObject_GetAttr(py_module, py_class_name);
    if (!result)
        goto bad;
    if (!PyType_Check(result)) {
        PyErr_Format(PyExc_TypeError, 
            "%s.%s is not a type object",
            module_name, class_name);
        goto bad;
    }
    if (((PyTypeObject *)result)->tp_basicsize != size) {
        PyErr_Format(PyExc_ValueError, 
            "%s.%s does not appear to be the correct type object",
            module_name, class_name);
        goto bad;
    }
    goto done;
bad:
    Py_XDECREF(result);
    result = 0;
done:
    Py_XDECREF(py_module_name);
    Py_XDECREF(py_class_name);
    Py_XDECREF(py_name_list);
    return (PyTypeObject *)result;
}

#include "compile.h"
#include "frameobject.h"
#include "traceback.h"

static void __Pyx_AddTraceback(char *funcname) {
    PyObject *py_srcfile = 0;
    PyObject *py_funcname = 0;
    PyObject *py_globals = 0;
    PyObject *empty_tuple = 0;
    PyObject *empty_string = 0;
    PyCodeObject *py_code = 0;
    PyFrameObject *py_frame = 0;
    
    py_srcfile = PyString_FromString(__pyx_filename);
    if (!py_srcfile) goto bad;
    py_funcname = PyString_FromString(funcname);
    if (!py_funcname) goto bad;
    py_globals = PyModule_GetDict(__pyx_m);
    if (!py_globals) goto bad;
    empty_tuple = PyTuple_New(0);
    if (!empty_tuple) goto bad;
    empty_string = PyString_FromString("");
    if (!empty_string) goto bad;
    py_code = PyCode_New(
        0,            /*int argcount,*/
        0,            /*int nlocals,*/
        0,            /*int stacksize,*/
        0,            /*int flags,*/
        empty_string, /*PyObject *code,*/
        empty_tuple,  /*PyObject *consts,*/
        empty_tuple,  /*PyObject *names,*/
        empty_tuple,  /*PyObject *varnames,*/
        empty_tuple,  /*PyObject *freevars,*/
        empty_tuple,  /*PyObject *cellvars,*/
        py_srcfile,   /*PyObject *filename,*/
        py_funcname,  /*PyObject *name,*/
        __pyx_lineno,   /*int firstlineno,*/
        empty_string  /*PyObject *lnotab*/
    );
    if (!py_code) goto bad;
    py_frame = PyFrame_New(
        PyThreadState_Get(), /*PyThreadState *tstate,*/
        py_code,             /*PyCodeObject *code,*/
        py_globals,          /*PyObject *globals,*/
        0                    /*PyObject *locals*/
    );
    if (!py_frame) goto bad;
    py_frame->f_lineno = __pyx_lineno;
    PyTraceBack_Here(py_frame);
bad:
    Py_XDECREF(py_srcfile);
    Py_XDECREF(py_funcname);
    Py_XDECREF(empty_tuple);
    Py_XDECREF(empty_string);
    Py_XDECREF(py_code);
    Py_XDECREF(py_frame);
}
